ALTER proc [dbo].[p_oms_export_30K] @sc int
AS --05092018 поправлен PRVS и PROFIL_K стационар
--08112018 встроил корректировку в выгрузку.
--03122018 встроил выгрузку из D3 по 200 приказу.
BEGIN
--declare @sc int = 47
--exec dbo.p_fix @sc

-- предварительная простановка обязательных полей.
update z set usl_ok=s.usl_ok 
from d3_zsl_oms z join d3_sl_oms s on s.d3_zslid=z.id
where z.usl_ok is null

update s set for_pom = case when extr=1 then 3 else 1 end
from sluch s where for_pom is null

update sl set nhistory=sl.id
from d3_sl_oms sl
where sl.nhistory is null
----

update sc set code=id from d3_schet_oms sc where code is null

declare  @d varchar(20) = convert(varchar,getdate(),105)


declare @Hf varchar(20),@Lf varchar(20)

declare @Hpref varchar(10) = (select SchetType from D3_SCHET_OMS where id=@sc)
declare @Lpref varchar(10)

if @Hpref='H'
	set @Lpref = 'L'
if @Hpref='C'
	set @Lpref = 'LC'


declare @CountV int --количество выгрузок данного реестра. пока не знаю в какое поле его можно записать.



-- работают только для всех годов и месяцев.
set @Hf = @Hpref+'M'+(select CODE_MO from [D3_SCHET_OMS] sc where id=@sc)+'T46_'+(select right(cast([year] as nvarchar(4)),2)+ right('0'+cast([MONTH] as nvarchar(2)),2) from [D3_SCHET_OMS] sc where id=@sc)+'1'
set @Lf = @Lpref+'M'+(select CODE_MO from [D3_SCHET_OMS] sc where id=@sc)+'T46_'+(select right(cast([year] as nvarchar(4)),2)+ right('0'+cast([MONTH] as nvarchar(2)),2) from [D3_SCHET_OMS] sc where id=@sc)+'1'



-- предобработка 
-- количество
declare @countD3 int = (select count(*) from d3_zsl_oms zsl where zsl.d3_scid=@sc )
declare @countSluch int = (select count(*) from sluch zsl where schet_id=@sc )



-- заполняем поля в счёте.
update sc set 
ZapFILENAME = @hf,PersFileName = @Lf
,SD_Z = @countD3+@countSluch
,SUMMAV = (select sum(sumv) from d3_zsl_oms zsl where zsl.d3_scid=@sc)+(select sum(sumv) from sluch zsl where zsl.schet_id=@sc)
,SUMMAP = (select sum(sumv) from d3_zsl_oms zsl where zsl.d3_scid=@sc)+(select sum(sumv) from sluch zsl where zsl.schet_id=@sc)
from d3_schet_oms sc where id=@sc

--номера записи N_ZAP и IDCASE

update p set N_ZAP = rowN from
(select ROW_NUMBER() OVER (ORDER BY zsl.id) rowN,p.id	from  [dbo].[SLUCH] zsl 
	join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc  ) sort
	join pacient p on sort.id=p.id

-- количество пациентов в D3 может быть меньше количества z_sl
update p set N_ZAP = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.id) + @countSluch as rowN,p.id
from  d3_pacient_oms p	where d3_scid=@sc ) sort 
join d3_pacient_oms p on sort.id=p.id

update zsl set IDCASE = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.n_zap,zsl.id)as rowN,zsl.id	from  [dbo].[SLUCH] zsl 
	join pacient p on zsl.pid=p.id 	where zsl.schet_id=@sc  ) sort 
join sluch zsl on sort.id=zsl.id

-- в старой таблице пациент = запись. в новой сделаем чтобы на одного пациента можно было несколько записей
update zsl set IDCASE = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.n_zap,zsl.id) + @countSluch as rowN,zsl.id
from  [dbo].[D3_ZSL_OMS] zsl join d3_pacient_oms p on zsl.d3_pid=p.id	where zsl.d3_scid=@sc  ) sort 
join [dbo].[D3_ZSL_OMS] zsl on sort.id=zsl.id

--конец предподготовки

select(
SELECT 
(SELECT '3.1' AS [VERSION],convert(date,[DSCHET],20) as [DATA]
	,@hf as [FILENAME], SD_Z
from [D3_SCHET_OMS] sc where id=@sc
FOR xml path('ZGLV'), TYPE) AS[*]
,
(SELECT [CODE],[CODE_MO],[YEAR],[MONTH],[NSCHET],convert(date,[DSCHET],20) [DSCHET],[PLAT], SUMMAV [SUMMAV],SUMMAP SUMMAP,[SANK_MEK],[SANK_MEE],[SANK_EKMP],[DISP]
	from [D3_SCHET_OMS] sc where id=@sc
FOR xml path('SCHET'), ELEMENTS , TYPE) AS[*]
---------------------------------
,(SELECT  p.N_ZAP,isnull(p.PR_NOV,0) PR_NOV	-- начало ZAP стационара
	, (select ID_PAC,VPOLIS,SPOLIS,NPOLIS,SMO,SMO_OGRN,SMO_OK,SMO_NAM
	--,INV нету
	,isnull(NOVOR, '0') NOVOR
	--,VNOV_D  нету
										FOR xml path('PACIENT'), TYPE) AS[*]
	, (select IDSLG as ZSL_ID -- начало Z_SL
		,IDCASE 
		,USL_OK,VIDPOM
		,FOR_POM,NPR_MO
		,convert(date,[DNAPR],20) as NPR_DATE -- добавить
		,(select top 1 CODE_MO from [D3_SCHET_OMS] sc where id=@sc) as LPU
		,convert(date,[DATE_1],20) DATE_Z_1,convert(date,[DATE_2],20) DATE_Z_2
		,null  as P_OTK -- дисп
		,null as RSLT_D --дисп
		,(select sum(zu.KDAY) from USL zu where zsl.id=zu.slid and left(CODE_USL,3)='TF1') as KD_Z --койкодни в усл в стационаре. причём у ВМП нет койкодней.
		,null as VNOV_M --где вес при рождении?
		,RSLT,ISHOD,OS_SLUCH
		,null as VB_P --Указывается" 1" только при оплате случая по КСГ с внутрибольничным переводом. - где брать?
		,(select newid() as SL_ID														-- начало SL
			,VID_HMP --  в файле T
			,METOD_HMP -- в файле Т
			,sl.LPU_1
			,ot.OTDID_REGION_NOTEDIT as PODR --составной код подразделения
			,sl.PROFIL
			,PROFIL_K
			,sl.DET
			,case when METOD_HMP is not null then convert(date,[DNAPR],20) end as TAL_D --Дата выдачи талона на ВМП (только вмп теперь)
			,case when METOD_HMP is not null then NNAPR end as TAL_NUM --Номер талона на ВМП
			,case when METOD_HMP is not null then convert(date,[DNAPR],20) end as TAL_P -- Дата планируемой госпитализации, да, на всё одна дата.
			,null as P_CEL
			,isnull(NHISTORY, sl.ID) as NHISTORY

			,Extr as P_PER -- норм подходит 1-планово 2-СМП 3 - перевод из другой МО 4 - перевод с другой МО с другого профиля
			,convert(date,sl.[DATE_IN],20) DATE_1,convert(date,sl.[DATE_OUT],20) DATE_2,sl.KDAY as KD,DS0, sl.DS DS1
			,null DS1_PR -- дисп Обязательно указывается "1", если основной диагноз выявлен впервые в результате проведенной диспансеризации/профилактического медицинского осмотра
			,1 as C_ZAB
			,case when vidpom=32 then 0 end as DS_ONK -- только для вмп выгружаем
			,null DN -- Указываются сведения о диспансерном наблюдении по поводу основного заболевания (состояния):1 - состоит,2 - взят,3 - не подлежит диспансерному наблюдению
			,(select DS DS2 from SLUCH_DS2 dss where dss.SLID = zsl.ID FOR xml path(''), ELEMENTS, TYPE) as[*]
			,null as DS3 -- нужно будет встроить таблицу.
			,CODE_MES1,CODE_MES2
			,case when sl.IDKSG is not null then
				(select case when year(sk.dbeg)<2019 then sk.KSGNUM else sl.IDKSG end as N_KSG,
						year(sk.dbeg) as VER_KSG
						, 0 KSG_PG, NULL AS N_KPG, (select top 1 kz from sprksg t join CalcKsgTarif t2 on t.ID = t2.IDKSG  and (sl.DATE_OUT >= t2.DBEG and sl.DATE_OUT < t2.DEND +1) and t.ksgnum =(select top 1 KSGNUM from SprKsg where id = sl.IDKSG) and stype = usl_ok  order by t2.id desc) AS KOEF_Z, 
	isnull((select top 1 upr from sprksg t join CalcUprk upr on t.ID = upr.IDKSG and (sl.DATE_OUT >= upr.TBEG and sl.DATE_OUT < upr.TEND +1) and t.ksgnum =(select top 1 KSGNUM from SprKsg where id = sl.IDKSG) and stype = usl_ok  order by upr.id desc), 1) AS KOEF_UP, 
	case when usl_ok =1 then 20853.43 else 11865.07 end AS BZTSZ, 1 AS KOEF_D, 
	(select top 1 kus from CalcMok as kf where kf.KOD_LPU = (select top 1 CODE_MO from [D3_SCHET_OMS] sc where id=@sc) AND (sl.DATE_OUT >= kf.DATESTART and (kf.DATEEND is NULL OR sl.DATE_OUT < kf.DATEEND +1)) order by id desc) AS KOEF_U,
	KSG_DKK AS DKK1, NULL AS DKK2, case when DIFF_K <> 1.00 then 1 else 0 end SL_K , case when DIFF_K <> 1.00 then DIFF_K else NULL end IT_SL
	 	,case when DIFF_K <> 1.00 then
		(select IDSL, Z_SL from USL_KSLP ks where ks.SLID = sl.ID FOR xml path('SL_KOEF'), ELEMENTS, TYPE) end AS[*]
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		FOR xml path('KSG_KPG'),ELEMENTS, TYPE) end AS[*]

				--(select (select top 1 KSGNUM from SprKsg where id = zu.IDKSG) as N_KSG -- здесь я так понимаю нужен не айдишник ксг, а реальный номер ксг, для стацонира свой, для дневного свой. нафига айдишник в случ сувать? лучше бы сразу номер ксг.
				--,NULL AS VER_KSG,null KSG_PG,NULL AS N_KPG,NULL AS KOEF_Z,NULL AS KOEF_UP,NULL AS BZTSZ,NULL AS KOEF_D, NULL AS KOEF_D,NULL AS DKK1,NULL AS DKK2,null SL_K,null IT_SL
				--					FOR xml path('KSG_KPG'), TYPE) end AS[*]
			,null REAB,PRVS21 as PRVS,'V021' as VERS_SPEC
			, sl.MSPUID as PRVS2, CODE_MD IDDOKT,sl.KOL_USL ED_COL,sl.TARIF,sl.SUMV_USL SUM_M
			,(select ROW_NUMBER() OVER (ORDER BY u.id) IDSERV					-- начало USL
				,isnull(LPU, zsl.LPU) LPU,LPU_1,PODR, isnull(PROFIL, zsl.PROFIL) PROFIL,VID_VME, isnull(DET, zsl.DET) DET,convert(date,[DATE_IN],20) DATE_IN,convert(date,[DATE_OUT],20) DATE_OUT
				,DS,CODE_USL,isnull(KOL_USL, 1) KOL_USL, isnull(TARIF, 0.00) TARIF, isnull(SUMV_USL, 0.00) SUMV_USL
				,(select top 1 cast(IDSPEC as int) from V002_V021 where IDPR_2 = PROFIL) PRVS,'V021' VERS_SPEC
				,mspuid as PRVS2
				
				--,PRVS	,'V015' VERS_SPEC
				,isnull (CODE_MD, zsl.IDDOKT) CODE_MD
				,null NPL,COMENTU
				from USL u where u.slid=zsl.id and isnull(u.PODR, '0')=isnull(sl.PODR, '0') and left(CODE_USL,3)<>'TF1'  FOR xml path('USL'), ELEMENTS , TYPE) AS[*]	
			,COMENTSL
			from USL sl join OtdelDb ot on sl.podr=ot.id and sl.slid=zsl.id and left(CODE_USL,3)='TF1' 	
				left join SprKsg sk on sk.id = sl.IDKSG FOR xml path('SL'), TYPE) AS[*] -- движение
		,IDSP,SUMV,OPLATA,SUMP
		,SANK_IT -- в версии 3.1 - SANKIT
										FOR xml path('Z_SL'), TYPE) AS[*]	from  [dbo].[SLUCH] zsl 
											join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc order by p.N_ZAP
	FOR xml path('ZAP'), ELEMENTS , TYPE) AS[*] -- ZAP стационара
	

--------------------------- -- начало ZAP поликлиники
,(SELECT p.N_ZAP,zsl.PR_NOV
	, (select ID_PAC,VPOLIS,SPOLIS,NPOLIS,ST_OKATO,SMO,SMO_OGRN,SMO_OK,SMO_NAM,INV,MSE,NOVOR,VNOV_D,VETERAN,WORK_STAT
			FOR xml path('PACIENT'), TYPE) AS[*]
	, (select ZSL_ID,IDCASE,zsl.USL_OK,VIDPOM,FOR_POM,NPR_MO
	,convert(date,[NPR_DATE],20) NPR_DATE 
	,LPU
	,VBR --дисп (обязательное)
	,convert(date,[DATE_Z_1],20) DATE_Z_1,convert(date,[DATE_Z_2],20) DATE_Z_2
	,P_OTK -- дисп (обязательное)
	,RSLT_D --дисп (обязательное)
	,KD_Z,VNOV_M,RSLT,ISHOD,OS_SLUCH
	,zsl.P_CEL as DISP -- в этом полее будет заранее сконвертированный OS_SLUCH_REGION по V016
	,OS_SLUCH_REGION
	,VOZR
	,VB_P
	--начало блока SL
	,(select SL_ID
	,VID_HMP ,METOD_HMP -- в файле Т
	,LPU_1
	,ot.OTDID_REGION_NOTEDIT as PODR -- подра нет и в SL в диспансеризации
	,sl.PROFIL
	,PROFIL_K 
	,DET
	,isnull(P_CEL25,P_CEL) as P_CEL --в эльмедицине в новой форме используется P_CEL25
	,TAL_NUM --Номер талона на ВМП
	,convert(date,[TAL_D],20) TAL_D --Дата выдачи талона на ВМП --их поидее нет если не вмп, а если есть - то это ошибка
	
	,convert(date,[TAL_P],20) TAL_P -- Дата планируемой госпитализации ВМП
	,NHISTORY
	,P_PER --(USL_OK=1 или USL_OK=2):1 - Самостоятельно 2 - СМИ 3 - Перевод из другой МО 4 - Перевод внутри МО с другого профиля
	,convert(date,[DATE_1],20) DATE_1,convert(date,[DATE_2],20) DATE_2,KD,DS0,DS1
	,DS1_PR -- дисп Обязательно указывается "1", если основной диагноз выявлен впервые в результате проведенной диспансеризации/профилактического медицинского осмотра
	--,DN as PR_D_N  --АС сказал что такого поля не будет.
	--подблоки Ds2 DS3
	,(select DS as DS2,DS_PR as DS2_PR
		,PR_DS2_N 
		 from D3_DSS_OMS dss where dss.D3_SLID = sl.ID and DS_TYPE=2 FOR xml path('DS2'), ELEMENTS, TYPE)  as[*]
	,(select DS as DS3 from D3_DSS_OMS dss where dss.D3_SLID = sl.ID and DS_TYPE=3 FOR xml path(''), ELEMENTS, TYPE) as[*]
	-- блок NAZ для диспансеризации
	,(select		NAZ_N -- номер по порядку
				,NAZ_R --заполняется при присвоении группы здоровья, кроме I и II.1 - направлен на консультацию в медицинскую организацию по месту прикрепления;2 - направлен на консультацию в иную медицинскую организацию;3 - направлен на обследование;4 - направлен в дневной стационар;5 - направлен на госпитализацию;6 - направлен в реабилитационное отделение.
				,NAZ_SP --Заполняется, если в поле NAZ_R проставлены коды 1 или 2.
				,NAZ_V --Заполняется, если в поле NAZ_R =3  ; 1 - лабораторная диагностика;2 - инструментальная диагностика;3 - методы лучевой диагностики, за исключением дорогостоящих;4 - дорогостоящие методы лучевой диагностики (КТ, МРТ, ангиография)
				,NAZ_USL -- V001, если (NAZ_R=3 и DS_ONK=1)
				,convert(date,[NAPR_DATE],20) NAPR_DATE
				,NAPR_MO --F003 (NAZ_R={2,3} и DS_ONK=1)
				,NAZ_PMP -- V002 профиль медпомощи Заполняется, если в поле NAZ_R проставлены коды 4 или 5.
				,NAZ_PK -- V020 профиль койки Заполняется, если в поле NAZ_R проставлен код 6.
		 from d3_naz_oms where d3_slid=sl.id
		 FOR xml path('NAZ'), TYPE) AS[*]
	,case when zsl.usl_ok<>4 then isnull(C_ZAB,1) end C_ZAB --3.1
	,case when @Hpref='C' or sl.p_cel25='2.2' then isnull(DS_ONK,0) end DS_ONK -- 3.1 дисп+вмп +C 1 - при выявлении подозрения на злокачественное новообразование
	,DN --Обязательно для заполнения, если P_CEL=1.3
	,CODE_MES1,CODE_MES2
	-- блок NAPR для вмп(почему то там тоже окология есть, блок при подозрении за онк)
	,(select convert(date,[NAPR_DATE],20) NAPR_DATE,NAPR_MO,NAPR_V,MET_ISSL,NAPR_USL 
		from d3_napr_oms na where na.d3_slid=sl.id
		FOR xml path('NAPR'), TYPE) AS[*] 
	-- Указываются сведения о диспансерном наблюдении по поводу основного заболевания (состояния):1 - состоит,2 - взят,3 - не подлежит диспансерному наблюдению
	-- блок CONS для вмп
	,(select PR_CONS,convert(date,[DT_CONS],20) DT_CONS 
		from d3_cons_oms con where con.d3_slid=sl.id
		FOR xml path('CONS'), TYPE) AS[*] 
	-- блок ONK_SL
	-- этого блока уже в 200 приказе нет в обычном реестре, зато есть в вмп.
	,(select DS1_T,STAD,ONK_T,ONK_N,ONK_M,nullif(MTSTZ,0) MTSTZ,SOD
		--блок B_DIAG
		,(SELECT convert(date,[DIAG_DATE],20) DIAG_DATE ,DIAG_TIP,DIAG_CODE,DIAG_RSLT,REC_RSLT
			from d3_b_diag_oms where d3_onkslid=onk.id
			FOR xml path('B_DIAG'), TYPE) AS[*] 
		--блок B_PROT
		,(SELECT PROT,convert(date,[D_PROT],20) D_PROT 
			from d3_b_prot_oms where d3_onkslid=onk.id
			FOR xml path('B_PROT'), TYPE) AS[*] 
		--блок ONK_USL
		,(select USL_TIP,HIR_TIP,LEK_TIP_L,LEK_TIP_V
				--,блок LEK_PR
				,(SELECT REGNUM,CODE_SH,convert(date,[DATE_INJ],20) DATE_INJ
					from d3_LEK_PR_oms where d3_onkuslid=onk_u.id
					FOR xml path('LEK_PR'), TYPE) AS[*] 
				,LUCH_TIP 
			from d3_onk_usl_oms onk_u where d3_onkslid=onk.id
			FOR xml path('ONK_USL'), TYPE) AS[*] 
		,SOD 
		from d3_onk_sl_oms onk where onk.d3_slid=sl.id
		FOR xml path('ONK_SL'), TYPE) AS[*] 
	
	,case when N_KSG is not null then --дублирование номера ксг, чтобы отделять ксг от других.
	(select isnull(ks.N_KSG,sl.N_KSG) N_KSG -- б
		,VER_KSG 
		,isnull(ks.KSG_PG,sl.KSG_PG) KSG_PG,N_KPG,KOEF_Z,KOEF_UP,BZTSZ,KOEF_D,KOEF_U,DKK1,DKK2,isnull(ks.SL_K,sl.SL_K) SL_K,isnull(ks.IT_SL,sl.IT_SL) IT_SL
		,(SELECT IDSL,Z_SL from d3_SL_KOEF_OMS kf where kf.D3_KSGID=ks.id FOR xml path('SL_KOEF'), TYPE ) AS[*]  ---3.1
		from D3_KSG_KPG_OMS ks where ks.D3_SLID=sl.id
		FOR xml path('KSG_KPG'), TYPE) end AS[*]
	,REAB --Указывается значение "1" для случаев реабилитации
	,PRVS --Указывается значение IDSPEC
	,PRVD,VERS_SPEC,IDDOKT,ED_COL,TARIF,SUM_M
	--блок USL   
	   ,(select ROW_NUMBER() OVER (ORDER BY u.id) IDSERV 
		,LPU,LPU_1
		,ot_u.OTDID_REGION_NOTEDIT as PODR
		,u.PROFIL,VID_VME,DET,convert(date,[DATE_IN],20) DATE_IN,convert(date,[DATE_OUT],20) DATE_OUT
		,DS,CODE_USL,isnull(KOL_USL,1) KOL_USL
		,TARIF,isnull(SUMV_USL,0) SUMV_USL
		,PRVS,VERS_SPEC,CODE_MD
		 ,isnull(P_OTK,0) P_OTK
		,NPL --Указывается причина, по которой услуга не оказана или оказана не в полном объеме.1 - документированный отказ больного,2 - медицинские противопоказания,3 - прочие причины (умер, переведен в другое отделение и пр.)4 - ранее проведенные услуги в пределах установленных сроков.
		,COMENTU
			from D3_USL_OMS u left join OtdelDb ot_u on u.podr=ot_u.id
				where u.d3_slid=sl.id FOR xml path('USL'), ELEMENTS , TYPE) AS[*]	
	,COMENTSL
		FROM [dbo].[D3_SL_OMS] sl  left join OtdelDb ot on sl.podr=ot.id --left потому что могут при диспансеризации и без отделения.
				where sl.d3_zslid=zsl.id 
		FOR xml path('SL'), TYPE) AS[*]
	
	,IDSP,SUMV
	FOR xml path('Z_SL'), TYPE) AS[*] 	from [dbo].[D3_ZSL_OMS] zsl join D3_pacient_OMS p on zsl.d3_scid=@sc and zsl.d3_pid=p.id	
		where p.d3_scid=@sc	order by N_ZAP
FOR xml path('ZAP'), ELEMENTS , TYPE) AS[*]


FOR XML path('ZL_LIST'), ELEMENTS, TYPE ) as HM
,(select 
	(
		SELECT 
			'3.1' as VERSION,
			convert(varchar(10),getdate(),20) as DATA,
			@Hf FILENAME,
			@Lf FILENAME1
		from D3_SCHET_OMS sch
		where sch.ID=@sc
		for xml path('ZGLV'),type
	),(	select 	  distinct  [ID_PAC]      ,[FAM]      ,[IM]      ,[OT]      ,[W]      
		,convert(varchar(10),P.DR,20) [DR]      ,[TEL]      ,[FAM_P]      ,[IM_P]      
		,[OT_P]      ,[W_P]      ,[DR_P]      ,[MR]      ,[DOCTYPE]      ,[DOCSER]
      ,[DOCNUM]      ,[SNILS]      ,[OKATOG]      ,[OKATOP]      ,[COMENTP]

		from  [dbo].[D3_ZSL_OMS] zsl join d3_pacient_oms p on zsl.d3_pid=p.id where zsl.d3_scid=@sc
	for xml path('PERS'),type )	 
	,	(	select distinct 
	   [ID_PAC]      ,[FAM]      ,[IM]      ,[OT]      ,[W]      ,convert(varchar(10),P.DR,20) [DR]
      ,null as [TEL]      ,[FAM_P]      ,[IM_P]      ,[OT_P]      ,[W_P]      ,[DR_P]      ,[MR]
      ,[DOCTYPE]      ,[DOCSER]      ,[DOCNUM]      ,[SNILS]      ,[OKATOG]      ,[OKATOP]      ,[COMENTP]
		from 
		  [dbo].[SLUCH] zsl  
			join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc	
		 for xml path('PERS'),type )
	
from D3_SCHET_OMS sch
where sch.ID=@sc
for xml path('PERS_LIST'),type) as LM
,@sc sc, @Hf hf_name, @lf lf_name


END