ALTER PROC [dbo].[p_oms_load_flk] @xml xml, @sc int as
begin

declare @flk_xml varchar(max)
select @flk_xml = '<?xml version="1.0" encoding="windows-1251"?> '+cast (@xml as varchar(max))
 declare @idflk int

 EXEC sp_xml_preparedocument @idflk OUTPUT, @flk_xml;

   if object_id('tempdb..#flk') is not null drop table #flk
select CAST (right(zsl_id_c,36) as uniqueidentifier)	ZSL_ID
--,ZSL_ID_C as 
,OSHIB,IM_POL,BAS_EL,N_ZAP,IDCASE,COMMENT into #flk
FROM  OPENXML (@idflk, N'FLK_P/PR',2)
            WITH (ZSL_ID_C nvarchar(100) 'COMMENT2' 

			,OSHIB int 'OSHIB'
			,IM_POL nvarchar(100) 'IM_POL'
			,BAS_EL nvarchar(100) 'BAS_EL'
			,N_ZAP int 'N_ZAP'
			,IDCASE int 'IDCASE'
			,COMMENT nvarchar(255) 'COMMENT'
			) p

-- очищаем поликлинику от флк за этот месяц.
UPDATE D3_ZSL_OMS SET EXP_COMENT = NULL where D3_SCID = @sc and EXP_COMENT is not null
-- вставляем ошибки флк в поликлинику.
UPDATE zsl SET EXP_COMENT =  cast(coment as nvarchar(500))
FROM D3_ZSL_OMS zsl 
join (
select ZSL_ID, (select DISTINCT ISNULL(tt.IM_POL, '') + ' ' + COMMENT, N'; ' from #flk tt where tt.zsl_id=t1.zsl_id for xml path('') ) COMENT
from #flk t1
Group by t1.ZSL_ID) tt2 on zsl.ZSL_ID = tt2.ZSL_ID and zsl.D3_SCID = @sc

-- очищаем стационар от флк за этот месяц.
UPDATE SLUCH SET EKMP_COMENT = NULL where SCHET_ID = @sc and EKMP_COMENT is not null
-- вставляем ошибки флк в стационар.
UPDATE zsl SET EKMP_COMENT =  cast(coment as varchar(250))
FROM SLUCH zsl 
join (
select ZSL_ID, (select DISTINCT ISNULL(tt.IM_POL, '') + ' ' + COMMENT, N'; ' from #flk tt where tt.zsl_id=t1.zsl_id for xml path('') ) COMENT
from #flk t1
Group by t1.ZSL_ID) tt2 on zsl.IDSLG = tt2.ZSL_ID and zsl.SCHET_ID = @sc
end