ALTER proc [dbo].[p_oms_export_30K] @sc int
AS --05092018 поправлен PRVS и PROFIL_K стационар
--08112018 встроил корректировку в выгрузку.
BEGIN
--declare @sc int = 47
--exec dbo.p_fix @sc

-- предварительная простановка обязательных полей.
update z set usl_ok=s.usl_ok 
from d3_zsl_oms z join d3_sl_oms s on s.d3_zslid=z.id
where z.usl_ok is null

update s set for_pom = case when extr=1 then 3 else 1 end
from sluch s where for_pom is null

update sl set nhistory=sl.id
from d3_sl_oms sl
where sl.nhistory is null
----

update sc set code=id from d3_schet_oms sc where code is null

declare  @d varchar(20) = convert(varchar,getdate(),105)

declare @Hf varchar(20),@Lf varchar(20)

-- проблемы данного скрипта:
--1. для заполнения хмл нужно зполнить в счёте summav,summap, sd_z
--2. нет таблицы назначений и диагнозов диспансеризации, неоткуда брать
--6. IDCASE нумерация - даже ROW_NUMBER() не срабатывает, хз как пронумеровать.

-- работают только для всех годов и месяцев.
set @Hf = 'HM'+(select CODE_MO from [D3_SCHET_OMS] sc where id=@sc)+'T46_'+(select right(cast([year] as nvarchar(4)),2)+ right('0'+cast([MONTH] as nvarchar(2)),2) from [D3_SCHET_OMS] sc where id=@sc)+'1'
set @Lf = 'LM'+(select CODE_MO from [D3_SCHET_OMS] sc where id=@sc)+'T46_'+(select right(cast([year] as nvarchar(4)),2)+ right('0'+cast([MONTH] as nvarchar(2)),2) from [D3_SCHET_OMS] sc where id=@sc)+'1'



-- предобработка 
-- количество
declare @countD3 int = (select count(*) from d3_zsl_oms zsl where zsl.d3_scid=@sc )
declare @countSluch int = (select count(*) from sluch zsl where schet_id=@sc )



-- заполняем поля в счёте.
update sc set 
ZapFILENAME = @hf,PersFileName = @Lf
,SD_Z = @countD3+@countSluch
,SUMMAV = (select sum(sumv) from d3_zsl_oms zsl where zsl.d3_scid=@sc)+(select sum(sumv) from sluch zsl where zsl.schet_id=@sc)
,SUMMAP = (select sum(sumv) from d3_zsl_oms zsl where zsl.d3_scid=@sc)+(select sum(sumv) from sluch zsl where zsl.schet_id=@sc)
from d3_schet_oms sc where id=@sc

--номера записи N_ZAP и IDCASE

update p set N_ZAP = rowN from
(select ROW_NUMBER() OVER (ORDER BY zsl.id) rowN,p.id	from  [dbo].[SLUCH] zsl 
	join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc  ) sort
	join pacient p on sort.id=p.id

-- количество пациентов в D3 может быть меньше количества z_sl
update p set N_ZAP = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.id) + @countSluch as rowN,p.id
from  d3_pacient_oms p	where d3_scid=@sc ) sort 
join d3_pacient_oms p on sort.id=p.id

update zsl set IDCASE = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.n_zap,zsl.id)as rowN,zsl.id	from  [dbo].[SLUCH] zsl 
	join pacient p on zsl.pid=p.id 	where zsl.schet_id=@sc  ) sort 
join sluch zsl on sort.id=zsl.id

-- в старой таблице пациент = запись. в новой сделаем чтобы на одного пациента можно было несколько записей
update zsl set IDCASE = rowN from
(select ROW_NUMBER() OVER (ORDER BY p.n_zap,zsl.id) + @countSluch as rowN,zsl.id
from  [dbo].[D3_ZSL_OMS] zsl join d3_pacient_oms p on zsl.d3_pid=p.id	where zsl.d3_scid=@sc  ) sort 
join [dbo].[D3_ZSL_OMS] zsl on sort.id=zsl.id

--конец предподготовки

select(
SELECT 
(SELECT '3.0K' AS [VERSION],convert(date,[DSCHET],20) as [DATA]
	,@hf as [FILENAME], SD_Z
from [D3_SCHET_OMS] sc where id=@sc
FOR xml path('ZGLV'), TYPE) AS[*]
,
(SELECT [CODE],[CODE_MO],[YEAR],[MONTH],[NSCHET],convert(date,[DSCHET],20) [DSCHET],[PLAT], SUMMAV [SUMMAV],SUMMAP SUMMAP,[SANK_MEK],[SANK_MEE],[SANK_EKMP],[DISP]
	from [D3_SCHET_OMS] sc where id=@sc
FOR xml path('SCHET'), ELEMENTS , TYPE) AS[*]
---------------------------------
,(SELECT  p.N_ZAP,isnull(p.PR_NOV,0) PR_NOV	-- начало ZAP стационара
	, (select ID_PAC,VPOLIS,SPOLIS,NPOLIS,SMO,SMO_OGRN,SMO_OK,SMO_NAM
	--,INV нету
	,isnull(NOVOR, '0') NOVOR
	--,VNOV_D  нету
										FOR xml path('PACIENT'), TYPE) AS[*]
	, (select IDSLG as ZSL_ID -- начало Z_SL
		,IDCASE 
		,USL_OK,VIDPOM
		,FOR_POM,NPR_MO
		,DNAPR as NPR_DATE -- добавить
		,(select top 1 CODE_MO from [D3_SCHET_OMS] sc where id=@sc) as LPU
		,convert(date,[DATE_1],20) DATE_Z_1,convert(date,[DATE_2],20) DATE_Z_2
		,null  as P_OTK -- дисп
		,null as RSLT_D --дисп
		,(select sum(zu.KDAY) from USL zu where zsl.id=zu.slid and left(CODE_USL,3)='TF1') as KD_Z --койкодни в усл в стационаре. причём у ВМП нет койкодней.
		,null as VNOV_M --где вес при рождении?
		,RSLT,ISHOD,OS_SLUCH
		,null as VB_P --Указывается" 1" только при оплате случая по КСГ с внутрибольничным переводом. - где брать?
		,(select newid() as SL_ID														-- начало SL
			,VID_HMP --  в файле T
			,METOD_HMP -- в файле Т
			,sl.LPU_1,sl.PODR,sl.PROFIL
			,PROFIL_K
			,sl.DET
			,DNAPR as TAL_D --Дата выдачи талона на ВМП
			,NNAPR as TAL_NUM --Номер талона на ВМП
			,null as TAL_P -- Дата планируемой госпитализации
			,null as P_CEL
			,isnull(NHISTORY, sl.ID) as NHISTORY

			,Extr as P_PER -- норм подходит 1-планово 2-СМП 3 - перевод из другой МО 4 - перевод с другой МО с другого профиля
			,convert(date,sl.[DATE_IN],20) DATE_1,convert(date,sl.[DATE_OUT],20) DATE_2,sl.KDAY as KD,DS0, sl.DS DS1
			,null DS1_PR -- дисп Обязательно указывается "1", если основной диагноз выявлен впервые в результате проведенной диспансеризации/профилактического медицинского осмотра
			--,DS_ONK -- 3.1 дисп
			,null DN -- Указываются сведения о диспансерном наблюдении по поводу основного заболевания (состояния):1 - состоит,2 - взят,3 - не подлежит диспансерному наблюдению
			,(select DS DS2 from SLUCH_DS2 dss where dss.SLID = zsl.ID FOR xml path(''), ELEMENTS, TYPE) as[*]
			,null as DS3 -- нужно будет встроить таблицу.
			,CODE_MES1,CODE_MES2
			,case when sl.IDKSG is not null then
				(select (select top 1 KSGNUM from SprKsg where id = sl.IDKSG) as N_KSG, 2018 AS VER_KSG, 0 KSG_PG, NULL AS N_KPG, (select top 1 kz from sprksg t join CalcKsgTarif t2 on t.ID = t2.IDKSG  and (sl.DATE_OUT >= t2.DBEG and sl.DATE_OUT < t2.DEND +1) and t.ksgnum =(select top 1 KSGNUM from SprKsg where id = sl.IDKSG) and stype = usl_ok  order by t2.id desc) AS KOEF_Z, 
	isnull((select top 1 upr from sprksg t join CalcUprk upr on t.ID = upr.IDKSG and (sl.DATE_OUT >= upr.TBEG and sl.DATE_OUT < upr.TEND +1) and t.ksgnum =(select top 1 KSGNUM from SprKsg where id = sl.IDKSG) and stype = usl_ok  order by upr.id desc), 1) AS KOEF_UP, 
	case when usl_ok =1 then 18834.99 else 8889.45 end AS BZTSZ, 1 AS KOEF_D, 
	(select top 1 kus from CalcMok as kf where kf.KOD_LPU = (select top 1 CODE_MO from [D3_SCHET_OMS] sc where id=@sc) AND (sl.DATE_OUT >= kf.DATESTART and (kf.DATEEND is NULL OR sl.DATE_OUT < kf.DATEEND +1)) order by id desc) AS KOEF_U,
	KSG_DKK AS DKK1, NULL AS DKK2, case when DIFF_K <> 1.00 then 1 else 0 end SL_K , case when DIFF_K <> 1.00 then DIFF_K else NULL end IT_SL
	 	,case when DIFF_K <> 1.00 then
		(select IDSL, Z_SL from USL_KSLP ks where ks.SLID = sl.ID FOR xml path('SL_KOEF'), ELEMENTS, TYPE) end AS[*]
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		FOR xml path('KSG_KPG'),ELEMENTS, TYPE) end AS[*]

				--(select (select top 1 KSGNUM from SprKsg where id = zu.IDKSG) as N_KSG -- здесь я так понимаю нужен не айдишник ксг, а реальный номер ксг, для стацонира свой, для дневного свой. нафига айдишник в случ сувать? лучше бы сразу номер ксг.
				--,NULL AS VER_KSG,null KSG_PG,NULL AS N_KPG,NULL AS KOEF_Z,NULL AS KOEF_UP,NULL AS BZTSZ,NULL AS KOEF_D, NULL AS KOEF_D,NULL AS DKK1,NULL AS DKK2,null SL_K,null IT_SL
				--					FOR xml path('KSG_KPG'), TYPE) end AS[*]
			,null REAB,PRVS21 as PRVS,'V021' as VERS_SPEC
			, sl.MSPUID as PRVS2, CODE_MD IDDOKT,sl.KOL_USL ED_COL,sl.TARIF,sl.SUMV_USL SUM_M
			,(select ROW_NUMBER() OVER (ORDER BY u.id) IDSERV					-- начало USL
				,isnull(LPU, zsl.LPU) LPU,LPU_1,PODR, isnull(PROFIL, zsl.PROFIL) PROFIL,VID_VME, isnull(DET, zsl.DET) DET,convert(date,[DATE_IN],20) DATE_IN,convert(date,[DATE_OUT],20) DATE_OUT
				,DS,CODE_USL,isnull(KOL_USL, 1) KOL_USL, isnull(TARIF, 0.00) TARIF, isnull(SUMV_USL, 0.00) SUMV_USL
				,(select top 1 cast(IDSPEC as int) from V002_V021 where IDPR_2 = PROFIL) PRVS,'V021' VERS_SPEC
				,mspuid as PRVS2
				
				--,PRVS	,'V015' VERS_SPEC
				,isnull (CODE_MD, zsl.IDDOKT) CODE_MD
				,null NPL,COMENTU
				from USL u where u.slid=zsl.id and isnull(u.PODR, '0')=isnull(zsl.PODR, '0') and left(CODE_USL,3)<>'TF1'  FOR xml path('USL'), ELEMENTS , TYPE) AS[*]	
			,COMENTSL
			from USL sl where sl.slid=zsl.id and left(CODE_USL,3)='TF1' 	FOR xml path('SL'), TYPE) AS[*] -- движение
		,IDSP,SUMV,OPLATA,SUMP
		,SANK_IT -- в версии 3.1 - SANKIT
										FOR xml path('Z_SL'), TYPE) AS[*]	from  [dbo].[SLUCH] zsl 
											join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc order by p.N_ZAP
	FOR xml path('ZAP'), ELEMENTS , TYPE) AS[*] -- ZAP стационара
	

--------------------------- -- начало ZAP поликлиники
,(SELECT p.N_ZAP,isnull(p.PR_NOV,0) PR_NOV
	, (select ID_PAC,VPOLIS,SPOLIS,NPOLIS,SMO,SMO_OGRN,SMO_OK,SMO_NAM --Pacient
		--,INV нету
		,isnull(NOVOR, '0') NOVOR
		--,VNOV_D  нету
			FOR xml path('PACIENT'), TYPE) AS[*]
	, (select ZSL_ID	--ZSL
		,IDCASE 
		,USL_OK,VIDPOM,FOR_POM,NPR_MO
		,null as NPR_DATE --  дата направления обычной медпомощи
		,case when os_sluch_region in (8,12,14,16,18,23) then 1 end  P_DISP2
		,isnull(LPU,(select top 1 CODE_MO from [D3_SCHET_OMS] sc where id=@sc)) as LPU
		,convert(date,[DATE_Z_1],20) DATE_Z_1,convert(date,[DATE_Z_2],20) DATE_Z_2
		,P_OTK	,RSLT_D --дисп
		,KD_Z,VNOV_M,RSLT,ISHOD,OS_SLUCH,VB_P, OS_SLUCH_REGION, VOZR
		,(select SL_ID,VID_HMP,METOD_HMP,LPU_1, PODR, PROFIL -- SL
			--	,PROFIL_K -- требуется V020
			,null PROFIL_K
			,DET
			/*!!!!! */	--P_CEL
			,P_CEL25 as P_CEL
			,P_CEL as P_CEL2 -- старое значение
			,TAL_D --Дата выдачи талона на ВМП
			,TAL_NUM --Номер талона на ВМП
			,TAL_P -- Дата планируемой госпитализации
			,NHISTORY -- у кого нет номера истории, берём айдишник. (в начале скрипт)
			,P_PER
			,convert(date,[DATE_1],20) DATE_1,convert(date,[DATE_2],20) DATE_2,KD,DS0,DS1
			--!!!!!!!!!!!!!!!!!	ds2
			,(select DS DS2 from D3_DSS_OMS dss where dss.D3_SLID = sl.ID and DS_TYPE = 2 FOR xml path(''), ELEMENTS, TYPE) as[*]
			,(select DS DS3 from D3_DSS_OMS dss where dss.D3_SLID = sl.ID and DS_TYPE = 3 FOR xml path(''), ELEMENTS, TYPE) as[*]
			--!!!!!!!!!!!!!!!!!	ds3
			,DS1_PR -- дисп Обязательно указывается "1", если основной диагноз выявлен впервые в результате проведенной диспансеризации/профилактического медицинского осмотра
			--,DS_ONK -- 3.1 дисп
			,DN -- Указываются сведения о диспансерном наблюдении по поводу основного заболевания (состояния):1 - состоит,2 - взят,3 - не подлежит диспансерному наблюдению
			--,case when PR_D_N is not null --  дисп Сопутствующие заболевания
			--		then (select null DS2,null DS2_PR --Обязательно указывается "1", если данный сопутствующий диагноз выявлен впервые 
			--			,null PR_DS2_N --1 - состоит,2 - взят,3 - не подлежит
			--		FOR xml path('DS2_N'), TYPE) end AS[*]
			--,case when PR_D_N is not null -- дисп назначения
			--		then(select null NAZ_N -- номер по порядку
			--			,null NAZ_R --заполняется при присвоении группы здоровья, кроме I и II.1 - направлен на консультацию в медицинскую организацию по месту прикрепления;2 - направлен на консультацию в иную медицинскую организацию;3 - направлен на обследование;4 - направлен в дневной стационар;5 - направлен на госпитализацию;6 - направлен в реабилитационное отделение.
			--			,null NAZ_SP --Заполняется, если в поле NAZ_R проставлены коды 1 или 2.
			--			,null NAZ_V --Заполняется, если в поле NAZ_R проставлен код 3.1 - лабораторная диагностика;2 - инструментальная диагностика;3 - методы лучевой диагностики, за исключением дорогостоящих;4 - дорогостоящие методы лучевой диагностики (КТ, МРТ, ангиография)
			--			,null NAZ_PMP -- профиль медпомощи Заполняется, если в поле NAZ_R проставлены коды 4 или 5.
			--			,null NAZ_PK -- профиль койки Заполняется, если в поле NAZ_R проставлен код 6.

			--			 FOR xml path('NAZ'), TYPE) end AS[*]

			--,CODE_MES1,CODE_MES2
			,case when N_KSG is not null then -- мы здесь стационар оставляем, потому что всё будет в омс таблицах.
				(select N_KSG, 2018 AS VER_KSG, 0 KSG_PG, NULL AS N_KPG, (select top 1 kz from sprksg t join CalcKsgTarif t2 on t.ID = t2.IDKSG  and (sl.DATE_2 >= t2.DBEG and sl.DATE_2 < t2.DEND +1) and t.ksgnum =n_ksg and stype = usl_ok  order by t2.id desc) AS KOEF_Z
				,isnull((select top 1 upr from sprksg t join CalcUprk upr on t.ID = upr.IDKSG and (sl.DATE_2 >= upr.TBEG and sl.DATE_2 < upr.TEND +1) and t.ksgnum =n_ksg and stype = usl_ok  order by upr.id desc), 1) AS KOEF_UP
				,case when usl_ok =1 then 18834.99 else 8889.45 end AS BZTSZ, 1 AS KOEF_D 
				,(select top 1 kus from CalcMok as kf where kf.KOD_LPU = zsl.LPU AND (sl.DATE_2 >= kf.DATESTART and (kf.DATEEND is NULL OR sl.DATE_2 < kf.DATEEND +1)) order by id desc) AS KOEF_U
				,KSG_DKK AS DKK1, NULL AS DKK2, case when IT_SL <> 1.00 then 1 else 0 end SL_K , case when IT_SL <> 1.00 then SL_K else NULL end IT_SL
	 			,case when IT_SL <> 1.00 then
					(select IDSL, Z_SL from D3_SL_KSLP_OMS ks where ks.SLID = sl.ID 
					FOR xml path('SL_KOEF'), ELEMENTS, TYPE) end AS[*]
				--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				FOR xml path('KSG_KPG'),ELEMENTS, TYPE) end AS[*]
				--!!!!!!!!!!!!!!!!!!!!! КСЛП
			,REAB
			,(select top 1 cast(IDSPEC as int) from V002_V021 where IDPR_2 = PROFIL) PRVS,'V021' VERS_SPEC
			,PRVS as PRVS2 --старый код
			,IDDOKT, isnull(ED_COL, 1) ED_COL, TARIF,SUM_M
			,case when zsl.OPLATA in (2,3) then
				(select top 1 S_CODE, S_SUM -- берём полное снятие, временно для смоленска.
					,S_TIP,f14.kod as S_OSN,S_COM,S_IST 
					from d3_sank_oms ss join F014 f14 on ss.s_osn=f14.osn  where ss.d3_zslid=zsl.id and f14.datebeg<zsl.DATE_Z_2
					order by s_sum desc 
				FOR xml path('SANK'), TYPE) end AS[*] -- 3.1 в приказе санк привязаны к sl, а в базе к zsl
			,(select ROW_NUMBER() OVER (ORDER BY zsl.id) IDSERV --USL
				,isnull(LPU, zsl.LPU) LPU, LPU_1,PODR, isnull(PROFIL, sl.PROFIL) PROFIL, VID_VME,isnull(DET, sl.DET) DET,convert(date,[DATE_IN],20) DATE_IN,convert(date,[DATE_OUT],20) DATE_OUT
				--,case when PR_D_N is not null then isnull(P_OTK,0) end P_OTK -- дисп
				,DS,CODE_USL
				,(select top 1 name from [dbo].[Yamed_Spr_Usl804] where id = VID_VME) USL, isnull(KOL_USL, 1) KOL_USL, isnull(TARIF, 0.00) TARIF ,isnull(SUMV_USL, 0.00) SUMV_USL
				,(select top 1 cast(IDSPEC as int) from V002_V021 where IDPR_2 = u.PROFIL) PRVS, 'V021' VERS_SPEC
				,PRVS PRVS2
				,isnull(CODE_MD, sl.IDDOKT) CODE_MD
				,NPL,COMENTU
				from D3_USL_OMS u where u.d3_slid=sl.id 
				FOR xml path('USL'), ELEMENTS , TYPE) AS[*]	
			,COMENTSL
			FROM [dbo].[D3_SL_OMS] sl  where sl.d3_zslid=zsl.id 
			FOR xml path('SL'), TYPE) AS[*]
		,IDSP,SUMV,OPLATA,SUMP
		SANK_IT -- в версии 3.1 - SANKIT
		FOR xml path('Z_SL'), TYPE) AS[*] 	
	from  [dbo].[D3_ZSL_OMS] zsl join d3_pacient_oms p on zsl.d3_pid=p.id	
			where zsl.d3_scid=@sc order by p.N_ZAP
	FOR xml path('ZAP'), ELEMENTS , TYPE) AS[*]


FOR XML path('ZL_LIST'), ELEMENTS, TYPE ) as HM
,(select 
	(
		SELECT 
			'3.0K' as VERSION,
			convert(varchar(10),getdate(),20) as DATA,
			@Hf FILENAME,
			@Lf FILENAME1
		from D3_SCHET_OMS sch
		where sch.ID=@sc
		for xml path('ZGLV'),type
	),(	select 	  distinct  [ID_PAC]      ,[FAM]      ,[IM]      ,[OT]      ,[W]      
		,convert(varchar(10),P.DR,20) [DR]      ,[TEL]      ,[FAM_P]      ,[IM_P]      
		,[OT_P]      ,[W_P]      ,[DR_P]      ,[MR]      ,[DOCTYPE]      ,[DOCSER]
      ,[DOCNUM]      ,[SNILS]      ,[OKATOG]      ,[OKATOP]      ,[COMENTP]

		from  [dbo].[D3_ZSL_OMS] zsl join d3_pacient_oms p on zsl.d3_pid=p.id where zsl.d3_scid=@sc
	for xml path('PERS'),type )	 
	,	(	select distinct 
	   [ID_PAC]      ,[FAM]      ,[IM]      ,[OT]      ,[W]      ,convert(varchar(10),P.DR,20) [DR]
      ,null as [TEL]      ,[FAM_P]      ,[IM_P]      ,[OT_P]      ,[W_P]      ,[DR_P]      ,[MR]
      ,[DOCTYPE]      ,[DOCSER]      ,[DOCNUM]      ,[SNILS]      ,[OKATOG]      ,[OKATOP]      ,[COMENTP]
		from 
		  [dbo].[SLUCH] zsl  
			join pacient p on zsl.pid=p.id	where zsl.schet_id=@sc	
		 for xml path('PERS'),type )
	
from D3_SCHET_OMS sch
where sch.ID=@sc
for xml path('PERS_LIST'),type) as LM
,@sc sc, @Hf hf_name, @lf lf_name


END