ALTER PROCEDURE [dbo].[p_fix] @sc int
AS
BEGIN


	declare @t table  (name varchar(255),cnt int) -- таблица-отчёт

	update d3_sl_oms set ED_COL =1 where ed_col is null

	insert into @t	select 'проставлено 1 вместо пустых единиц: ',@@rowcount

	update p set smo=null,smo_ogrn=null,smo_ok=null,smo_nam=null,spolis=null,vpolis=null
	FROM [PACIENT] p where len(isnull(npolis,0))<2 and (smo is not null or smo_ogrn is not null or smo_ok is not null or smo_nam is not null or spolis is not null or vpolis is not null )
	insert into @t	select 'очищено СМО у бесполисных стационара: ',@@rowcount

	update p set smo=null,smo_ogrn=null,smo_ok=null,smo_nam=null,spolis=null,vpolis=null
	FROM d3_PACIENT_oms p where len(isnull(npolis,0))<2 and (smo is not null or smo_ogrn is not null or smo_ok is not null or smo_nam is not null or spolis is not null or vpolis is not null )
	insert into @t	select 'очищено СМО у бесполисных поликлиники: ',@@rowcount

	update sl set p_cel=null,p_cel25=null from [D3_SL_OMS] sl join d3_zsl_oms zsl on zsl.id=sl.d3_zslid where zsl.usl_ok=4 and zsl.d3_scid=@sc
	insert into @t	select 'очищены цели посещения в скорой помощи: ',@@rowcount

	update s set for_pom = case when extr=1 then 3 else 1 end from sluch s where schet_id=@sc
	insert into @t	select 'проставлена форма помощи в стационаре: ',@@rowcount

	update sl set nhistory=zsl.id from d3_zsl_oms zsl join d3_sl_oms sl on zsl.id=sl.d3_zslid and zsl.d3_scid=@sc
	where sl.nhistory is null
	insert into @t	select 'присвоен новый номер истории случаям в поликлинике: ',@@rowcount

	update sc set code=id from d3_schet_oms sc where code is null
	insert into @t	select 'проставлен code счетам, равный id: ',@@rowcount

	-- фикс подразделений LPU_1
	update sl set LPU_1 = case when zsl.usl_ok=3 then 301 when zsl.usl_ok=4 then 401 end
	FROM [dbo].[D3_SL_OMS] sl join d3_zsl_oms zsl on zsl.id=sl.d3_zslid where sl.LPU_1 is null
	insert into @t	select 'заполнено пропущенное поле LPU_1: ',@@rowcount

	
	update sl set 
	--PRVS = cast(IDSPEC as int),
	VERS_SPEC = 'V021'
	from D3_SL_OMS sl join d3_zsl_oms zsl on sl.d3_zslid=zsl.id and zsl.usl_ok in (3,4)
	--join V002_V021 v on IDPR_2 = PROFIL
	where VERS_SPEC is null and zsl.d3_scid=@sc
	--PRVS <>IDSPEC 
	insert into @t	select 'Поправлена версия специальности на V021 (поликл, скорая): ',@@rowcount
	

	update zs set idsp=9
	FROM [D3_ZSL_OMS] zs
	  inner join [D3_SL_OMS] sl on zs.id=sl.[D3_ZSLID]
	where 
	  zs.D3_SCID = @sc
	  and zs.usl_ok = 3
	  and zs.OS_SLUCH_REGION is null
	  and sl.PROFIL in (63,85,86,87,88,89,90,171)
	  and zs.idsp not in (9)
    insert into @t	select 'Поправлен способ оплаты в стоматологии: ',@@rowcount

	update zs set RSLT =359
	FROM [D3_ZSL_OMS] zs where	(zs.OS_SLUCH_REGION in (37,38)
      and zs.RSLT not in (359)) and zs.D3_SCID = @sc
    insert into @t	select 'Проставлен результат в осслуч 37,38 равный 359: ',@@rowcount
 
    update zs set RSLT =314
	FROM [D3_ZSL_OMS] zs where	(zs.OS_SLUCH_REGION in (4,5,21,29,30,31,32,33,34,35,6,36,39)
      and zs.RSLT not in (314)) and zs.D3_SCID = @sc
    insert into @t	select 'Проставлен результат в осслуч (4,5,21,29,30,31,32,33,34,35,6,36,39) равный 314: ',@@rowcount

	update zs set ISHOD =306
	FROM [D3_ZSL_OMS] zs where	(zs.OS_SLUCH_REGION in (4,5,7,8,9,11,12,17,18,21,22,23,29,30,31,32,33,34,37,38)
    and zs.[ISHOD] not in (306)) and zs.D3_SCID = @sc
    insert into @t	select 'Проставлен исход в осслуч (4,5,7,8,9,11,12,17,18,21,22,23,29,30,31,32,33,34,37,38) равный 306: ',@@rowcount

	select name,cnt from @t
END