ALTER PROCEDURE [dbo].[p_doc_op_dokt2] @sc int, @smo nvarchar(20) = ''
AS -- 26.04.2018 texnix отчёт по врачам по шаблону ДП7 Оксаны Владимировны.
--07082018 переделаны цели25
--16082018 v021
--03092018 v021 стационар
--02102018 новый вид отчётов
BEGIN

	select 3 tip,tsl,name ,FIO,null obr,sum(klvo) pos,sum(ed_col) uet, (sumv) summ from
	(
	Select 
	( CASE 	WHEN zsl.usL_ok=4 THEN 'Скорая помощь' -- скорую помощь ставим первой, так как у неё могут поставить цель.
			WHEN OS_SLUCH_REGION is null and zsl.usL_ok=3 and sl.p_cel25 is not null THEN v25.N_PC
			WHEN OS_SLUCH_REGION is null and zsl.usL_ok=3 and sl.p_cel25 is null THEN 'Иная цель посещения'
			
		   ELSE os.name
			end) as tsl,
	SUMV,sp.SpecName as name, case when sp.SpecName like '%стом%' then ed_col end ed_col -- уеты только в стоматологии
	,1 klvo,sp.idspec,d.FIO
	from D3_ZSL_OMS zsl join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID and zsl.D3_SCID = @sc
	join V021 sp on sl.prvs = sp.idspec
	join d3_pacient_oms p on zsl.D3_PID=p.id and (@smo in ('','0') or (@smo='46' and (p.SMO is null or p.SMO not like '46%')) or (p.SMO = @smo and @smo like '460%')) 
	join (select distinct FIO,snils from [Yamed_Spr_MedicalEmployee]) d on sl.iddokt=d.snils
	left join OsobSluchDb os on zsl.OS_SLUCH_REGION = os.Id
	left join V025 v25 on v25.IDPC=sl.p_cel25
	where isnull(sl.P_CEL25,'')<>'3.0'  -- без обращения
	 ) pose
	group by tsl,name,FIO,SUMV
	
	union all
	select 1 tip,tsl,name,[NameWithId] as FIO,null as obr,count(*) pos,sum(CountKkd) uet, sum(summ) summ
	from

	(select 
	( 
	
	CASE 	WHEN Os_Sluch_Region=35 THEN 'Телеконсультация'
									WHEN sl.Usl_ok=1 THEN 'Стационар'
			WHEN sl.Usl_ok=2 and Os_Sluch_Region is null THEN 'Дневной стационар'
			WHEN sl.Usl_ok=2 and Os_Sluch_Region in (19) THEN 'СОД'
						WHEN s.lpu_1=202 THEN 'Дневной стационар при поликлинике'
			 WHEN s.lpu_1=203 THEN 'Дневной стационар на дому'
		   ELSE 'Не проставлен тип случая'
			end) as tsl
	,isnull(sp.name,sp21.SPECNAME) name,d.[NameWithId]
		,(case 
		when sl.usl_ok=1 and datediff(dd,DATE_1,DATE_2)=0 then datediff(dd,DATE_1,DATE_2)+1
		when sl.usl_ok=1 and datediff(dd,DATE_1,DATE_2)>0 then datediff(dd,DATE_1,DATE_2)

		when sl.usl_ok=2 and datediff(dd,DATE_1,DATE_2)+1=1 then datediff(dd,DATE_1,DATE_2)+1
		when sl.usl_ok=2 and o.id!=7 and datediff(dd,DATE_1,DATE_2)+1>1 then datediff(dd,DATE_1,DATE_2)+1
		when sl.usl_ok=2 and o.id=7 and datediff(dd,DATE_1,DATE_2)+1>1 then datediff(dd,DATE_1,DATE_2)+1-
		(select count(h_date)from work_day where h_date between DATE_1 and DATE_2 )
	else 0 end)  as CountKkd
	,sl.SUMV as summ
	from D3_SL_OMS s
	join D3_ZSL_OMS sl on sl.ID=s.D3_ZSLID
	join D3_PACIENT_OMS p on sl.D3_PID=p.id and sl.D3_SCID =   @sc and (@smo in ('','0') or (@smo='46' and (p.SMO is null or p.SMO not like '46%')) or (p.SMO = @smo and @smo like '460%')) 
	join [Yamed_Spr_MedicalEmployee] d on S.IDDOKT=d.SNILS
	join otdeldb o on s.podr=o.id
	--join D3_USL_OMS u on s.id=u.D3_SLID
	left join V015 sp on s.PRVS = sp.id
	left join V021 sp21 on s.PRVS21=sp21.IDSPEC
	 ) st
	
	group by tsl,name,[NameWithId]
	union all 
	select 2 tip,'Обращения по заболеванию' tsl,name,FIO ,sum(obr) obr,sum(pos) pos,sum(uet) uet, sum(sumv) summ from
	(select name,FIO,case when DATE_Z_2=datezsl then 1 else 0 end obr,klvo as pos,ed_col as uet
	,case when DATE_Z_2=datezsl then sumv else 0 end sumv -- +79513164417 Оксана Владимировна сказала что сумма и обращение присваиваются тому доктору, который закрыл обращение.
	 from	(
	Select zsl.ID,d.FIO,max(date_z_2) datezsl,max(DATE_Z_2) DATE_Z_2,max(SUMV) sumv,max(SpecName) name, case when max(SpecName) like '%стом%' then sum(ed_col) end ed_col,count(distinct sl.id) klvo
	from D3_ZSL_OMS zsl join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID and zsl.D3_SCID = @sc
	join V021 sp on sl.prvs = sp.idspec
	join [Yamed_Spr_MedicalEmployee] d on sl.iddokt=d.snils
	join d3_pacient_oms p on zsl.D3_PID=p.id and (@smo in ('','0') or (@smo='46' and (p.SMO is null or p.SMO not like '46%')) or (p.SMO = @smo and @smo like '460%')) 
	where sl.P_CEL25='3.0' -- только обращения
	 group by zsl.ID,d.FIO ) k) polik group by name,FIO

order by tsl,name,FIO

end
