ALTER PROCEDURE [dbo].[p_doc_op_foms] @sc int
AS
BEGIN

WITH Z AS (select max(SUMV) sumv,max(sl.P_CEL25)p_cel,max(OS_SLUCH_REGION) OS_SLUCH_REGION-- готовая выборка для всей поликлиники
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID --and (pa.SMO is null or pa.SMO not like '46%')
where zsl.usl_ok = 3 and (OS_SLUCH_REGION IS NULL OR OS_SLUCH_REGION in (4,5,6,21,29,30,31,32,33,34,35,36,39))
group by zsl.ID)

--declare @sc int =1625

Select '1' n, 'Медицинская помощь в условиях круглосуточных стационаров' cel, sum(SUMV) sumv, count(*) cnt
FROM(
Select zsl.ID, max(SUMV) sumv
from D3_ZSL_OMS zsl 
join D3_SL_OMS sl on zsl.ID = sl.D3_ZSLID
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where zsl.usl_ok = 1 
group by zsl.ID) tt

UNION ALL

Select '2' n, 'Медицинская помощь в условиях дневных стационаров всех типов' cel, sum(SUMV) sumv, count(*) cnt
FROM(
Select zsl.ID, max(SUMV) sumv
from D3_ZSL_OMS zsl 
join D3_SL_OMS sl on zsl.ID = sl.D3_ZSLID
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where zsl.usl_ok = 2
group by zsl.ID) tt

UNION ALL

Select '3' n, 'Амбулаторная помощь' cel
	, sum(SUMV) sumv, count(*) cnt
from z
UNION ALL
Select '' n, '  - с профилактическими и иными целями' cel, sum(SUMV) sumv, count(*) cnt
from z
where (
	     ((z.P_CEL LIKE '1%' AND z.P_CEL NOT LIKE '1.1')	OR 	z.P_CEL IN ('2.1','2.5','2.6')	AND OS_SLUCH_REGION IS null)					
		 or OS_SLUCH_REGION in (4,5,29,35) 
	  )
UNION ALL
Select '' n, '  - Неотложной форме' cel, sum(SUMV) sumv, count(*) cnt
from z where P_CEL = '1.1'  -- новый код неотложки  = 1.1
UNION ALL
Select '' n, '  - Обращение по заболеванию' cel, sum(SUMV) sumv, count(*) cnt 
from z where (P_CEL = '3.0' and OS_SLUCH_REGION is null)
	or OS_SLUCH_REGION in (6,21,30,31,32,33,34,36,39) 
union all
Select '4' n, 'Скорая медицинская помощь в том числе:' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID
where zsl.usl_ok = 4 
UNION ALL
Select '' n, '   - экстренной форме' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID
where zsl.usl_ok = 4  and zsl.FOR_POM = 1 
UNION ALL
Select '' n, '   - неотложной форме' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID
where zsl.usl_ok = 4  and zsl.FOR_POM = 2 

UNION ALL


Select '5' n, 'Профосмотры взрослых' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION = 9
UNION ALL

Select '6' n,
case 
 WHEN OS_SLUCH_REGION = 11 THEN 'Профилактический медицинский осмотр несовершеннолетних 1 этап'
  WHEN OS_SLUCH_REGION = 12 THEN 'Профилактический медицинский осмотр несовершеннолетних 2 этап'
end cel,
sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION in (11, 12)
group by 
case 
 WHEN OS_SLUCH_REGION = 11 THEN 'Профилактический медицинский осмотр несовершеннолетних 1 этап'
  WHEN OS_SLUCH_REGION = 12 THEN 'Профилактический медицинский осмотр несовершеннолетних 2 этап'
end

UNION ALL

Select '7' n,
case 
 WHEN OS_SLUCH_REGION = 22 THEN 'Диспансеризация определенных групп взрослого населения 1 этап'
  WHEN OS_SLUCH_REGION = 23 THEN 'Диспансеризация определенных групп взрослого населения 2 этап'
end cel,
sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION in (22, 23)
group by 
case 
 WHEN OS_SLUCH_REGION = 22 THEN 'Диспансеризация определенных групп взрослого населения 1 этап'
  WHEN OS_SLUCH_REGION = 23 THEN 'Диспансеризация определенных групп взрослого населения 2 этап'
end


UNION ALL
Select '8' n,
case 
 WHEN OS_SLUCH_REGION = 7 THEN 'Диспансеризация детей сирот 1 этап'
  WHEN OS_SLUCH_REGION = 8 THEN 'Диспансеризация детей сирот 2 этап'
end cel,
sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION in (7, 8)
group by 
case 
 WHEN OS_SLUCH_REGION = 7 THEN 'Диспансеризация детей сирот 1 этап'
  WHEN OS_SLUCH_REGION = 8 THEN 'Диспансеризация детей сирот 2 этап'
end


UNION ALL

Select '9' n,
case 
 WHEN OS_SLUCH_REGION = 17 THEN 'Диспансеризация детей под опекой 1 этап'
  WHEN OS_SLUCH_REGION = 18 THEN 'Диспансеризация детей под опекой 2 этап'
end cel,
sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION in (17, 18)
group by 
case 
 WHEN OS_SLUCH_REGION = 17 THEN 'Диспансеризация детей под опекой 1 этап'
  WHEN OS_SLUCH_REGION = 18 THEN 'Диспансеризация детей под опекой 2 этап'
end

UNION ALL

Select '10' n,
case 
 WHEN OS_SLUCH_REGION = 37 THEN 'ДВ3_К'
  WHEN OS_SLUCH_REGION = 38 THEN 'ДВ3_М'
end cel,
sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SCHET_OMS sc on zsl.D3_SCID = sc.ID and sc.ID in (@sc)
join D3_PACIENT_OMS pa on zsl.D3_PID = pa.ID
where OS_SLUCH_REGION in (37, 38)
group by 
case 
 WHEN OS_SLUCH_REGION = 37 THEN 'ДВ3_К'
  WHEN OS_SLUCH_REGION = 38 THEN 'ДВ3_М'
end



END

