CREATE procedure [dbo].[p_load_Packet]	
/*declare */
@Nxml varchar(max),@FileName varchar(200)
as 
begin


/*приготавливаем хмл, который быстрее считывается в 2008 скуэль сервере */
/*SELECT @Nxml = cast(data AS varchar(max)) FROM openrowset(BULK 'c:\base\xml\F014.XML', SINGLE_BLOB) AS T(data) */

Declare @rez int = 0 /* результат, нашли ли обработку для поданного хмл файла или нет. */
declare @i int =0
declare @typeSpr varchar(50)
/* поддерживаемые типы справочников. */
/*LIC_PROF - лицензии профилей TS05 алтай22 */
/*LIC_SPEC - лицензии специальностей TS06 алтай22 */
/*LIC_USL - лицензии услуг TS07 алтай22 если найдена услуга такая, то проверяем остальные параметры. если параметры не совпадают - снимать. */
/*MKBTP - оплачиваемые диагнозы. (LIC_MKB) */
/*F002 */
/*F003 */
declare @reg varchar(2)
declare @tf_okato nvarchar(5) /* получаем окато текущей СМО. */
SELECT @tf_okato = tf_okato FROM [F002] where smocod = (select Parametr from Settings where name='CodeSMO')
select @reg=Parametr from Settings where name='Region'
if @tf_okato is null /* берём и МО. */
	SELECT @tf_okato = tf_okato FROM [F003] where mcod = (select Parametr from Settings where name='MedicalOrganization')


 declare @idxml int
EXEC sp_xml_preparedocument @idxml OUTPUT, @Nxml;


 SELECT @typeSpr =[type]    /*федеральные */
	FROM openxml(@idxml, '/packet/zglv', 2)	    WITH  (  type VARCHAR(36) 'type'    )
 if @typeSpr is null   
	SELECT @typeSpr =[type]  /*территориальные 	алтая */
		FROM openxml(@idxml, '/PACKET/ZGLV', 2)			WITH  (  type VARCHAR(36) '@TYPE'    )
	
 /* теперь Fки, они не по стандарту. */
declare @tipk int
if @typeSpr is null
	begin
		SELECT @tipk=count(smocod) FROM openxml(@idxml, '/packet/insCompany', 2)
			WITH  (	  smocod VARCHAR(255) 'smocod'		)
		if @tipk>0 
			set @typeSpr='F002'
    end 
if @typeSpr is null
	begin
		SELECT @tipk=count(mcod) FROM openxml(@idxml, '/packet/medCompany', 2)
			WITH( mcod VARCHAR(255) 'mcod'	)
		if @tipk>0 
			set @typeSpr='F003'
    end 
if @typeSpr is null
	begin
		SELECT @tipk=count(ID) FROM openxml(@idxml, '/book/entries/entry', 2)
			WITH (	ID int 'ID'	)
		if @tipk>0 
			set @typeSpr='V011'
    end  
/*теперь региональные Иваново 37 */
if @typeSpr is null
	SELECT @typeSpr =[tip]  
		FROM openxml(@idxml, '/SPRAV/ZGLV', 2)			WITH  (  tip VARCHAR(36) 'FILENAME'    )

	

/*SELECT @typeSpr */
/*это по заголовку, ещё можем по @FileName определять тип хмл */


/*начинаем транзакцию */
begin tran

if @typeSpr='rg001' 
	begin
		merge rg001 as target 		using
		(select F1,F2
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KATEGOR' 
				,F2 nvarchar(255) 'NAIM'   ) )as source
				on target.KATEGOR=source.F1 
			when matched then 	update set target.NAIM = source.F2 

			when not matched BY TARGET then
				insert (KATEGOR,NAIM)
				values (F1,F2);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='rg003' 
	begin
		merge rg003 as target 		using
		(select F1,F2
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KC' 
				,F2 nvarchar(255) 'NC'   ) )as source
				on target.KC=source.F1 
			when matched then 	update set target.NC = source.F2 

			when not matched BY TARGET then
				insert (KC,NC)
				values (F1,F2);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='rg004' 
	begin
		merge rg004 as target 		using
		(select F1,F2
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KOD' 
				,F2 nvarchar(255) 'NAIM'   ) )as source
				on target.KOD=source.F1 
			when matched then 	update set target.NAIM = source.F2 

			when not matched BY TARGET then
				insert (KOD,NAIM)
				values (F1,F2);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='rg005' 
	begin
		merge rg005 as target 		using
		(select F1,F2,replace(F3,',','.') F3,F4,DB,nullif(DE,'') DE
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'IDSL' 
				,F2 nvarchar(255) 'NPR'
				,F3 nvarchar(255) 'ZKOEF' 
				,F4 nvarchar(255) 'USLKOEF'
				,DB nvarchar(100) 'DATEBEG'
				,DE nvarchar(100) 'DATEEND'   ) )as source
				on target.IDSL=source.F1 and target.NPR=source.F2	and  target.DATEBEG=source.DB
			when matched then 	update set target.DATEEND = source.DE

			when not matched BY TARGET then
				insert (IDSL,NPR,ZKOEF,USLKOEF,DATEBEG,DATEEND)
				values (F1,F2,F3,F4,DB,DE);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end

if @typeSpr='rg006' 
	begin
		merge rg006 as target 		using
		(select F1,F2,F3
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'GLN' 
				,F2 nvarchar(255) 'KOD_LPU'
				,F3 nvarchar(255) 'NAIM_LPU' 
				  ) )as source
				on target.KOD_LPU=source.F2 
			when matched then 	update set target.NAIM_LPU = source.F3

			when not matched BY TARGET then
				insert (GLN,KOD_LPU,NAIM_LPU)
				values (F1,F2,F3);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='rg006' 
	begin
		merge rg006 as target 		using
		(select F1,F2,F3
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'GLN' 
				,F2 nvarchar(255) 'KOD_LPU'
				,F3 nvarchar(255) 'NAIM_LPU' 
				  ) )as source
				on target.KOD_LPU=source.F2 
			when matched then 	update set target.NAIM_LPU = source.F3

			when not matched BY TARGET then
				insert (GLN,KOD_LPU,NAIM_LPU)
				values (F1,F2,F3);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end

if @typeSpr='rg007' 
	begin
		merge rg007 as target 		using
		(select F1,F2,F3
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KUSL' 
				,F2 nvarchar(255) 'NUSL'
				,F3 nvarchar(255) 'CUSL' 
				  ) )as source
				on target.KUSL=source.F1 
			when matched then 	update set target.NUSL = source.F2

			when not matched BY TARGET then
				insert (KUSL,NUSL,CUSL)
				values (F1,F2,F3);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end

if @typeSpr='rg008' 
	begin
		merge rg008 as target 		using
		(select F1,F2,replace(F3,',','.') F3,F4,DB,nullif(DE,'') DE
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KUSL' 
				,F2 nvarchar(255) 'NUSL'
				,F3 nvarchar(255) 'CUSL' 
				,F4 nvarchar(255) 'PDETI'
				,DB nvarchar(100) 'DT_BEG'
				,DE nvarchar(100) 'DT_FIN'   ) )as source
				on target.KUSL=source.F1 and target.CUSL=source.F3	and  target.DT_BEG=source.DB
			when matched then 	update set target.DT_FIN = source.DE

			when not matched BY TARGET then
				insert (KUSL,NUSL,CUSL,PDETI,DT_BEG,DT_FIN)
				values (F1,F2,F3,F4,DB,DE);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='rg009' 
	begin
		merge rg009 as target 		using
		(select F1,F2
			FROM  OPENXML (@idxml, N'/SPRAV/ZAP',3)
				WITH (F1 nvarchar(255) 'KOD' 
				,F2 nvarchar(255) 'NAME'   ) )as source
				on target.KOD=source.F1 
			when matched then 	update set target.NAME = source.F2 

			when not matched BY TARGET then
				insert (KOD,NAME)
				values (F1,F2);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end

if @typeSpr='rg010' 
	begin
		merge rg010 as target 		using  		(
		select F1,F2,F3,F4,DB,nullif(DE,'') DE,F5,F6,F7,F8,F9,F10,F11,F12
			FROM  OPENXML (@idxml, N'/SPRAV/MO/TAR/ZAP',3)
				WITH (F1 nvarchar(255) '../../KOD_LPU' 
				,F2 nvarchar(255) 'N_ST' /*40000.1 есть */
				,F3 nvarchar(255) 'NAIM' 
				,F4	nvarchar(255) 'SR_DL' 
				,DB nvarchar(100) 'DT_BEG'				 
				,DE nvarchar(100) 'DT_FIN'
				,F5 nvarchar(255) 'TARIF'
				,F6 nvarchar(255) 'BZTSZ'
				,F7 nvarchar(255) 'KOEF_Z'
				,F8 nvarchar(255) 'KOEF_UP'
				,F9 nvarchar(255) 'KOEF_D'
				,F10 nvarchar(255) 'KOEF_U'
				,F11 nvarchar(255) 'DN'
				,F12 nvarchar(255) 'N_ST_STR'   ) 
				
				)as source
				on target.KOD_LPU=source.F1 and target.N_ST=source.F2	and  target.DT_BEG=source.DB
			when matched then 	update set target.DT_FIN = source.DE

			when not matched BY TARGET then
				insert (KOD_LPU,N_ST,NAIM,SR_DL,DT_BEG,DT_FIN,TARIF,BZTSZ,KOEF_Z,KOEF_UP,KOEF_D,KOEF_U,DN,N_ST_STR)
				values (F1,F2,F3,F4,DB,DE,F5,F6,F7,F8,F9,F10,F11,F12);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	   
		
	end

if @typeSpr='rg011' 
	begin
		merge rg011 as target 		using  		(
		select F1,F2,F3,F4,DB,nullif(DE,'') DE,F5
			FROM  OPENXML (@idxml, N'/SPRAV/MO/TAR/ZAP',3)
				WITH (F1 nvarchar(255) '../../KOD_LPU' 
				,F2 nvarchar(255) 'KOD' 
				,F3 nvarchar(255) 'NAIM' 
				,F4	nvarchar(255) 'SR_DL' 
				,DB nvarchar(100) 'DT_BEG'				 
				,DE nvarchar(100) 'DT_FIN'
				,F5 nvarchar(255) 'TARIF'
				   ) 
				
				)as source
				on target.KOD_LPU=source.F1 and target.KOD=source.F2	and  target.DT_BEG=source.DB
			when matched then 	update set target.DT_FIN = source.DE

			when not matched BY TARGET then
				insert (KOD_LPU,KOD,NAIM,SR_DL,DT_BEG,DT_FIN,TARIF)
				values (F1,F2,F3,F4,DB,DE,F5);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	   
		
	end

if @typeSpr='rg012' 
	begin
		merge rg012 as target 		using  		(
		select F1,F2,F3,F4,F5,DB,nullif(DE,'') DE,F6,F7,F8
			FROM  OPENXML (@idxml, N'/SPRAV/MO/TAR/ZAP',3)
				WITH (F1 nvarchar(255) '../../KOD_LPU' 
				,F2 nvarchar(255) 'KOD_SP' 
				,F3 nvarchar(255) 'NSP' 
				,F4	nvarchar(255) 'KODUSL' 
				,F5	nvarchar(255) 'NUSL'
				,DB nvarchar(100) 'DT_BEG'				 
				,DE nvarchar(100) 'DT_FIN'
				,F6 nvarchar(255) 'TARIF'
				,F7	nvarchar(255) 'USL_OK'
				,F8	nvarchar(255) 'CODE_USL'
				   ) 
				
				)as source
				on target.KOD_LPU=source.F1 and target.KOD_SP=source.F2	and  target.DT_BEG=source.DB
			when matched then 	update set target.DT_FIN = source.DE

			when not matched BY TARGET then
				insert (KOD_LPU,KOD_SP,NSP,KODUSL,NUSL,DT_BEG,DT_FIN,TARIF,USL_OK,CODE_USL)
				values (F1,F2,F3,F4,F5,DB,DE,F6,F7,F8);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	   
		
	end
if @typeSpr='rg013' 
	begin
		merge rg013 as target 		using  		(
		select F1,F2,F3,F4,F5,DB,nullif(DE,'') DE,F6
			FROM  OPENXML (@idxml, N'/SPRAV/MO/TAR/ZAP',3)
				WITH (F1 nvarchar(255) '../../KOD_LPU' 
				,F2 nvarchar(255) 'VID_BRIG' 
				,F3 nvarchar(255) 'NBRIG' 
				,F4	nvarchar(255) 'VID_VIZ' 
				,F5	nvarchar(255) 'NVIZ'
				,DB nvarchar(100) 'DT_BEG'				 
				,DE nvarchar(100) 'DT_FIN'
				,F6 nvarchar(255) 'TARIF'
				   ) 
				
				)as source
				on target.KOD_LPU=source.F1 and target.VID_BRIG=source.F2	and  target.DT_BEG=source.DB  and  target.VID_VIZ=source.F4
			when matched then 	update set target.DT_FIN = source.DE

			when not matched BY TARGET then
				insert (KOD_LPU,VID_BRIG,NBRIG,VID_VIZ,NVIZ,DT_BEG,DT_FIN,TARIF)
				values (F1,F2,F3,F4,F5,DB,DE,F6);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	   
		
	end
if @typeSpr='DopKr' 
	begin
		merge V024 as target 		using
		(select IDDKK,DKKNAME,DATEBEG,nullif(DATEEND,'') DATEEND
		 from (select ROW_NUMBER ( ) over (PARTITION BY IDDKK,DATEBEG order by DATEEND ) rn,
		   IDDKK,cast(DKKNAME as nvarchar(254)) DKKNAME,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDDKK nvarchar(255) 'IDDKK' 
				,DKKNAME nvarchar(1000) 'DKKNAME' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND'  ) )k where rn=1
				)as source
				on target.IDDKK=source.IDDKK and target.DATEBEG = source.DATEBEG 
			when matched then 	update set target.DATEEND = source.DATEEND , target.DKKNAME = source.DKKNAME /* в таких же записях может только дата окончания поменяться. */

			when not matched BY TARGET then
				insert (IDDKK,DKKNAME,DATEBEG,DATEEND)
				values (IDDKK,DKKNAME,DATEBEG,DATEEND);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='DispT' 
	begin
		merge V016 as target 		using
		(select IDDT,DTNAME,DTRULE,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap/DTRULE/RULE',3)
				WITH (IDDT nvarchar(255) '../../IDDT' 
				,DTNAME nvarchar(255) '../../DTNAME' 
				,DTRULE nvarchar(255) '.'
				,DATEBEG nvarchar(100) '../../DATEBEG' 
				,DATEEND nvarchar(100) '../../DATEEND'  ) 
				where year(DATEEND) not in (2013,2014,2015,2016,2017) /*отрезаем старые данные, чтобы не хламить справочник */
				) as source
				on target.IDDT=source.IDDT and target.DATEBEG = source.DATEBEG and target.DTRULE=source.DTRULE
			when matched then 	update set target.DATEEND = source.DATEEND /* в таких же записях может только дата окончания поменяться. */

			when not matched BY TARGET then
				insert (IDDT,DTNAME,DTRULE,DATEBEG,DATEEND)
				values (IDDT,DTNAME,DTRULE,DATEBEG,DATEEND);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='DispR' 
	begin
		merge V017 as target 		using
		(select IDDR,DRNAME,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDDR nvarchar(255) 'IDDR' 
				,DRNAME nvarchar(255) 'DRNAME' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND'  ) 
				where year(DATEEND) not in (2013,2014,2015,2016,2017) /*отрезаем старые данные, чтобы не хламить справочник */
				) as source
				on target.IDDR=source.IDDR and target.DATEBEG = source.DATEBEG 
			when matched then 	update set target.DATEEND = source.DATEEND /* в таких же записях может только дата окончания поменяться. */

			when not matched BY TARGET then
				insert (IDDR,DRNAME,DATEBEG,DATEEND)
				values (IDDR,DRNAME,DATEBEG,DATEEND);
		
		set @rez = isnull(@@ROWCOUNT,0)
		if @@ERROR<>0 set @i = 1
	end
if @typeSpr='F002'
	begin
		merge F002 as target
			using  	( select 
		cast(nullif([tf_okato],'') as nvarchar(5)) tf_okato,smocod,cast(nullif([nam_smop],'') as nvarchar(250)) nam_smop,cast(nullif([nam_smok],'') as nvarchar(250)) nam_smok
		,cast(nullif([inn],'') as nvarchar(12)) inn,cast(nullif([Ogrn],'') as nvarchar(15)) Ogrn,cast(nullif([KPP],'') as nvarchar(9)) KPP
		,cast(nullif([okopf],'') as nvarchar(5)) okopf,cast(nullif([fam_ruk],'') as nvarchar(40)) fam_ruk,cast(nullif([im_ruk],'') as nvarchar(40)) im_ruk,cast(nullif([ot_ruk],'') as nvarchar(40)) ot_ruk,cast(nullif([phone],'') as nvarchar(40)) phone
		  FROM  OPENXML (@idxml, N'/packet/insCompany',3)
					WITH (
			tf_okato nvarchar(1000) 'tf_okato',
			smocod nvarchar(1000) 'smocod',
			nam_smop nvarchar(1000) 'nam_smop',
			nam_smok nvarchar(1000) 'nam_smok',
			inn nvarchar(1000) 'inn',
			Ogrn nvarchar(1000) 'Ogrn',
			KPP nvarchar(1000) 'KPP',
			okopf nvarchar(1000) 'okopf',
			fam_ruk nvarchar(1000) 'fam_ruk',
			im_ruk nvarchar(1000) 'im_ruk',
			ot_ruk nvarchar(1000) 'ot_ruk',
			phone nvarchar(1000) 'phone'
			/*d_edit nvarchar(1000) 'd_edit' */
					) 
					) as source
			on target.smocod=source.smocod
		when matched then 	update set target.nam_smop = source.nam_smop,target.nam_smok = source.nam_smok
			,target.fam_ruk = source.fam_ruk,target.im_ruk = source.im_ruk,target.ot_ruk = source.ot_ruk
			,target.phone = source.phone
		when not matched BY TARGET then
			insert (tf_okato,smocod,nam_smop,nam_smok,inn,Ogrn,KPP,okopf,fam_ruk,im_ruk,ot_ruk,phone)
			values (tf_okato,smocod,nam_smop,nam_smok,inn,Ogrn,KPP,okopf,fam_ruk,im_ruk,ot_ruk,phone);
	set @rez = isnull(@@ROWCOUNT,0)
	if @@ERROR<>0 set @i = 1
end

if @typeSpr='F003'
begin
	merge F003 as target
		using  	( select 
    cast(nullif([tf_okato],'') as nvarchar(5)) tf_okato,cast(nullif([mcod],'') as nvarchar(6)) mcod,cast(nullif([nam_mop],'') as nvarchar(250)) nam_mop,cast(nullif([nam_mok],'') as nvarchar(250)) nam_mok,cast(nullif([inn],'') as nvarchar(12)) inn,cast(nullif([Ogrn],'') as nvarchar(15)) Ogrn,cast(nullif([KPP],'') as nvarchar(9)) KPP,cast(nullif([index_j],'') as nvarchar(6)) index_j,cast(nullif([addr_j],'') as nvarchar(254)) addr_j,cast(nullif([okopf],'') as nvarchar(5)) okopf,cast(nullif([vedpri],'') as numeric(3,0)) vedpri,cast(nullif([org],'') as numeric(1,0)) org,cast(nullif([fam_ruk],'') as nvarchar(40)) fam_ruk,cast(nullif([im_ruk],'') as nvarchar(40)) im_ruk,cast(nullif([ot_ruk],'') as nvarchar(40)) ot_ruk,cast(nullif([phone],'') as nvarchar(40)) phone,cast(nullif([fax],'') as nvarchar(40)) fax,cast(nullif([e_mail],'') as nvarchar(50)) e_mail,cast(nullif([n_doc],'') as nvarchar(30)) n_doc,cast(nullif([d_start],'') as datetime) d_start,cast(nullif([data_e],'') as datetime) data_e,cast(nullif([mp],'') as nvarchar(20)) mp,cast(nullif([www],'') as nvarchar(100)) www,cast(nullif([d_begin],'') as datetime) d_begin,cast(nullif([d_end],'') as datetime) d_end,cast(nullif([name_e],'') as nvarchar(10)) name_e,cast(nullif([DUVED],'') as datetime) DUVED,cast(nullif([d_edit],'') as datetime) d_edit
	  FROM  OPENXML (@idxml, N'packet/medCompany',3)
				WITH (
        tf_okato nvarchar(1000) 'tf_okato',
        mcod nvarchar(1000) 'mcod',
        nam_mop nvarchar(1000) 'nam_mop',
        nam_mok nvarchar(1000) 'nam_mok',
        inn nvarchar(1000) 'inn',
        Ogrn nvarchar(1000) 'Ogrn',
        KPP nvarchar(1000) 'KPP',
        index_j nvarchar(1000) 'index_j',
        addr_j nvarchar(1000) 'addr_j',
        okopf nvarchar(1000) 'okopf',
        vedpri nvarchar(1000) 'vedpri',
        org nvarchar(1000) 'org',
        fam_ruk nvarchar(1000) 'fam_ruk',
        im_ruk nvarchar(1000) 'im_ruk',
        ot_ruk nvarchar(1000) 'ot_ruk',
        phone nvarchar(1000) 'phone',
        fax nvarchar(1000) 'fax',
        e_mail nvarchar(1000) 'e_mail',
        n_doc nvarchar(1000) 'n_doc',
        d_start nvarchar(1000) 'd_start',
        data_e nvarchar(1000) 'data_e',
        mp nvarchar(1000) 'mp',
        www nvarchar(1000) 'www',
        d_begin nvarchar(1000) 'd_begin',
        d_end nvarchar(1000) 'd_end',
        name_e nvarchar(1000) 'name_e',
        DUVED nvarchar(1000) 'DUVED',
        d_edit nvarchar(1000) 'd_edit'
				) where tf_okato=@tf_okato or mcod like @Reg+'%' /*только того же региона */
				) as source
		on target.mcod=source.mcod 
	when matched then 	update set target.d_end = source.d_end,target.nam_mop = source.nam_mop,target.nam_mok = source.nam_mok
			,target.fam_ruk = source.fam_ruk,target.im_ruk = source.im_ruk,target.ot_ruk = source.ot_ruk
			,target.phone = source.phone
	when not matched BY TARGET then
		insert (Id,tf_okato,mcod,nam_mop,nam_mok,inn,Ogrn,KPP,index_j,addr_j,okopf,vedpri,org,fam_ruk,im_ruk,ot_ruk,phone,fax,e_mail,n_doc,d_start,data_e,mp,www,d_begin,d_end,name_e,DUVED,d_edit)
		values (mcod,tf_okato,mcod,nam_mop,nam_mok,inn,Ogrn,KPP,index_j,addr_j,okopf,vedpri,org,fam_ruk,im_ruk,ot_ruk,phone,fax,e_mail,n_doc,d_start,data_e,mp,www,d_begin,d_end,name_e,DUVED,d_edit);
set @rez = isnull(@@ROWCOUNT,0)
if @@ERROR<>0 set @i = 1
end
if @typeSpr='V011'
begin
	merge V011 as target
		using  	( select 
		ID,nullif([S_NUM_REG],'') S_NUM_REG     ,nullif([DATE_REG],'')  DATE_REG    ,nullif([DATE_END_REG],'')   DATE_END_REG
		,nullif([DATE_CANCEL_REG],'')  DATE_CANCEL_REG    ,nullif([S_ORG_NAME],'') S_ORG_NAME ,cast(nullif([S_ORG_COUNTRY],'') as nvarchar(150))  S_ORG_COUNTRY
		,cast(nullif([S_TORG_NAME],'') as nvarchar(150))  S_TORG_NAME    ,cast(nullif([S_MNN],'') as nvarchar(150)) S_MNN     
		,cast(nullif([S_FORMS],'') as nvarchar(150))  S_FORMS,cast(nullif([S_PROD_PHASE],'') as nvarchar(150)) S_PROD_PHASE   
		,cast(nullif([S_CODES],'') as nvarchar(150)) S_CODES ,cast(nullif([S_DOCS],'') as nvarchar(150)) S_DOCS 
		,nullif([S_FARM_GROUP],'')	S_FARM_GROUP
	  FROM  OPENXML (@idxml, N'book/entries/entry',3)
				WITH (ID int 'ID' 
				,S_NUM_REG nvarchar(100) 'S_NUM_REG' 
				,DATE_REG nvarchar(100) 'DATE_REG' 
				,DATE_END_REG nvarchar(100) 'DATE_END_REG' 
				,DATE_CANCEL_REG nvarchar(100) 'DATE_CANCEL_REG' 
				,S_ORG_NAME nvarchar(500) 'S_ORG_NAME' 
				,S_ORG_COUNTRY nvarchar(255) 'S_ORG_COUNTRY'
				,S_TORG_NAME nvarchar(255) 'S_TORG_NAME'
				,S_MNN nvarchar(255) 'S_MNN'
				,S_FORMS nvarchar(255) 'S_FORMS'
				,S_PROD_PHASE nvarchar(255) 'S_PROD_PHASE'
				,S_CODES nvarchar(255) 'S_CODES'
				,S_DOCS nvarchar(255) 'S_DOCS'
				,S_FARM_GROUP nvarchar(500) 'S_FARM_GROUP'
				) where DATE_REG<>'' /*почемуто в конце левые записи с пустой датой регистрации и датой вместо S_NUM_REG */
				) as source
		on target.ID=source.ID and target.S_NUM_REG = source.S_NUM_REG
	when matched then 	update set target.DATE_END_REG = source.DATE_END_REG,target.DATE_CANCEL_REG = source.DATE_CANCEL_REG  /* в таких же записях может только дата окончания поменяться. */

	when not matched BY TARGET then
		insert ([ID],[S_NUM_REG],[DATE_REG],[DATE_END_REG],[DATE_CANCEL_REG],[S_ORG_NAME],[S_ORG_COUNTRY],[S_TORG_NAME],[S_MNN],[S_FORMS],[S_PROD_PHASE],[S_CODES],[S_DOCS],[S_FARM_GROUP])
		values ([ID],[S_NUM_REG],[DATE_REG],[DATE_END_REG],[DATE_CANCEL_REG],[S_ORG_NAME],[S_ORG_COUNTRY],[S_TORG_NAME],[S_MNN],[S_FORMS],[S_PROD_PHASE],[S_CODES],[S_DOCS],[S_FARM_GROUP]);
set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
if @typeSpr='LIC_SPEC'
begin
	merge LIC_SPEC as target
		using  
		(select nullif(LPU,'') LPU,nullif(LPU_1,'') LPU_1,nullif(DLIC_START,'') DLIC_START
			,nullif(DLIC_STOP,'') DLIC_STOP,nullif(MEDSPEC,'') MEDSPEC,nullif(IDUMP,'') IDUMP,nullif(IDVMP,'') IDVMP
			FROM  OPENXML (@idxml, N'PACKET/ZAP',3)
				WITH (LPU nvarchar(100) '@LPU' 
				,LPU_1 nvarchar(100) '@LPU_1' 
				,DLIC_START nvarchar(100) '@DLIC_START' 
				,DLIC_STOP nvarchar(100) '@DLIC_STOP' 
				,MEDSPEC nvarchar(100) '@MEDSPEC' 
				,IDUMP nvarchar(100) '@IDUMP' 
				,IDVMP nvarchar(100) '@IDVMP' 
			
				)
		) as source
		on target.LPU=source.LPU and isnull(target.LPU_1,'')=isnull(source.LPU_1,'') and target.DLIC_START=source.DLIC_START and target.MEDSPEC=source.MEDSPEC and target.IDUMP=source.IDUMP and target.IDVMP=source.IDVMP
	when matched then 	update set target.DLIC_STOP = source.DLIC_STOP /* в таких же записях может только дата окончания поменяться. */

	when not matched BY TARGET then
		insert (LPU,LPU_1,DLIC_START,DLIC_STOP,MEDSPEC,IDUMP,IDVMP)
		values (LPU,LPU_1,DLIC_START,DLIC_STOP,MEDSPEC,IDUMP,IDVMP);
set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
if @typeSpr='LIC_PROF'
begin
	merge LIC_PROF as target
		using  
		(select distinct nullif(LPU,'') LPU,nullif(LPU_1,'') LPU_1,nullif(DLIC_START,'') DLIC_START
			,nullif(DLIC_STOP,'') DLIC_STOP,nullif(IDPR,'') IDPR,nullif(IDUMP,'') IDUMP,nullif(IDVMP,'') IDVMP
			FROM  OPENXML (@idxml, N'PACKET/ZAP',3)
				WITH (LPU nvarchar(100) '@LPU' 
				,LPU_1 nvarchar(100) '@LPU_1' 
				,DLIC_START nvarchar(100) '@DLIC_START' 
				,DLIC_STOP nvarchar(100) '@DLIC_STOP' 
				,IDPR nvarchar(100) '@IDPR' 
				,IDUMP nvarchar(100) '@IDUMP' 
				,IDVMP nvarchar(100) '@IDVMP' 
			
				)
		) as source
		on target.LPU=source.LPU and isnull(target.LPU_1,'')=isnull(source.LPU_1,'') and target.DLIC_START=source.DLIC_START and target.IDPR=source.IDPR and target.IDUMP=source.IDUMP and target.IDVMP=source.IDVMP
	when matched then 	update set target.DLIC_STOP = source.DLIC_STOP /* в таких же записях может только дата окончания поменяться. */

	when not matched BY TARGET then
		insert (LPU,LPU_1,DLIC_START,DLIC_STOP,IDPR,IDUMP,IDVMP)
		values (LPU,LPU_1,DLIC_START,DLIC_STOP,IDPR,IDUMP,IDVMP);	
set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
if @typeSpr='LIC_USL'
begin
	merge LIC_USL as target
		using  
		(select nullif(LPU,'') LPU,nullif(LPU_1,'') LPU_1,nullif(DLIC_START,'') DLIC_START
			,nullif(DLIC_STOP,'') DLIC_STOP,nullif(CODE_USL,'') CODE_USL,nullif(IDUMP,'') IDUMP,nullif(IDVMP,'') IDVMP
			FROM  OPENXML (@idxml, N'PACKET/ZAP',3)
				WITH (LPU nvarchar(100) '@LPU' 
				,LPU_1 nvarchar(100) '@LPU_1' 
				,DLIC_START nvarchar(100) '@DLIC_START' 
				,DLIC_STOP nvarchar(100) '@DLIC_STOP' 
				,CODE_USL nvarchar(100) '@CODE_USL' 
				,IDUMP nvarchar(100) '@IDUMP' 
				,IDVMP nvarchar(100) '@IDVMP' 
			
				)
		) as source
		on target.LPU=source.LPU and isnull(target.LPU_1,'')=isnull(source.LPU_1,'') and target.DLIC_START=source.DLIC_START and target.CODE_USL=source.CODE_USL and target.IDUMP=source.IDUMP and target.IDVMP=source.IDVMP
	when matched then 	update set target.DLIC_STOP = source.DLIC_STOP /* в таких же записях может только дата окончания поменяться. */

	when not matched BY TARGET then
		insert (LPU,LPU_1,DLIC_START,DLIC_STOP,CODE_USL,IDUMP,IDVMP)
		values (LPU,LPU_1,DLIC_START,DLIC_STOP,CODE_USL,IDUMP,IDVMP);
set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
if @typeSpr='MKBTP'
begin
	/*мкб перезаписываем при каждой новой загрузке. */
	delete from LIC_MKB where tf_okato=@tf_okato

	merge LIC_MKB as target
		using  
		(select @tf_okato as tf_okato,nullif(DS,'') DS,nullif(IDUMP,'') IDUMP
			FROM  OPENXML (@idxml, N'PACKET/ZAP',3)
				WITH (DS nvarchar(100) '@DS' 
				,IDUMP nvarchar(100) '@IDUMP' 
				)
		) as source
		on target.tf_okato=source.tf_okato and isnull(target.DS,'')=isnull(source.DS,'') and target.IDUMP=source.IDUMP 
	when not matched BY TARGET then
		insert (tf_okato,DS,IDUMP)
		values (tf_okato,DS,IDUMP);

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
/*V025 */
if @typeSpr='KPC'
begin
	merge V025 as target
		using  
		(select IDPC,N_PC,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDPC nvarchar(100) 'IDPC' 
				,N_PC nvarchar(100) 'N_PC' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' 
				)
		) as source
		on target.IDPC=source.IDPC
	when matched then 	update set target.DATEEND = source.DATEEND,target.N_PC = source.N_PC
	when not matched BY TARGET then
		insert (IDPC,N_PC,DATEBEG,DATEEND)
		values (IDPC,N_PC,DATEBEG,DATEEND);

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
/*F006 в F006_NEW */
if @typeSpr='VidExp'
begin
	merge F006_NEW as target
		using  
		(select IDVID,VIDNAME,DATEBEG,DATEEND
			from (select ROW_NUMBER ( ) over (PARTITION BY IDVID order by DATEEND ) rn,
			IDVID,VIDNAME,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDVID nvarchar(100) 'IDVID' 
				,VIDNAME nvarchar(255) 'VIDNAME' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' 
				)  )k where rn=1 
		) as source
		on target.IDVID=source.IDVID
	when matched then 	update set target.DATEEND = source.DATEEND,target.VIDNAME = source.VIDNAME
	when not matched BY TARGET then
		insert (IDVID,VIDNAME,DATEBEG,DATEEND,EXP_TYPE,EXP_RE)
		values (IDVID,VIDNAME,DATEBEG,DATEEND,case when IDVID<20 then 1 when IDVID<30 then 2 else 3 end,0);

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end

if @typeSpr='OplOtk'
begin
	merge F014 as target
		using  
			(select Kod,nullif(IDVID,'') IDVID,Naim,Osn,Comments,KodPG,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (
				Kod nvarchar(10) 'Kod' 
				,IDVID nvarchar(10) 'IDVID'
				,Naim nvarchar(1000) 'Naim'
				,Osn nvarchar(20) 'Osn'
				,Comments nvarchar(1000) 'Komment'
				,KodPG nvarchar(20) 'KodPG' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' 
				)  
		) as source
		on target.Osn=source.Osn  and target.DATEBEG=source.DATEBEG
	when matched then 	update set target.DATEEND = source.DATEEND,target.Naim = source.Naim
	when not matched BY TARGET then
		insert (Kod,IDVID,Naim,Osn,Comments,KodPG,DATEBEG,DATEEND)
		values (Kod,IDVID,Naim,Osn,Comments,KodPG,DATEBEG,DATEEND);

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
/*V010	// пример как отрезать одинаковые значения, обновив название */
if @typeSpr='Sposob'
begin
	merge V010 as target
		using  
		(select IDSP,SPNAME,DATEBEG,DATEEND from
(select ROW_NUMBER ( ) over (PARTITION BY IDSP order by DATEEND ) rn,
IDSP,SPNAME,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDSP int 'IDSP' 
				,SPNAME nvarchar(100) 'SPNAME' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' ) )k where rn=1 
		) as source
		on target.IDSP=source.IDSP
	when matched then 	update set target.DATEEND = source.DATEEND,target.SPNAME = source.SPNAME
	when not matched BY TARGET then
		insert (id,IDSP,SPNAME,DATEBEG,DATEEND)
		values (IDSP,IDSP,SPNAME,DATEBEG,DATEEND) ;

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end
/*V008 */
if @typeSpr='VidMp'
begin
	merge V008 as target
		using  
		(select IDVMP,VMPNAME,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (IDVMP nvarchar(100) 'IDVMP' 
				,VMPNAME nvarchar(254) 'VMPNAME' 
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' 
				)
		) as source
		on target.ID=source.IDVMP
	when matched then 	update set target.DATEEND = source.DATEEND,target.VMPNAME = source.VMPNAME
	when not matched BY TARGET then
		insert (ID,VMPNAME,DATEBEG,DATEEND)
		values (IDVMP,VMPNAME,DATEBEG,DATEEND);

set @rez = isnull(@@ROWCOUNT,0)

if @@ERROR<>0 set @i = 1
end

/*V009 */
if @typeSpr='Rezult'
begin
	merge V009 as target
		using  
		(select F1,F2,F3,DATEBEG,nullif(DATEEND,'') DATEEND
			FROM  OPENXML (@idxml, N'packet/zap',3)
				WITH (F1 nvarchar(100) 'IDRMP' 
				,F2 nvarchar(254) 'RMPNAME' 
				,F3 nvarchar(254) 'DL_USLOV'
				,DATEBEG nvarchar(100) 'DATEBEG' 
				,DATEEND nvarchar(100) 'DATEEND' 
				)
		) as source
		on target.IDRMP=source.F1
	when matched then 	update set target.DATEEND = source.DATEEND
	when not matched BY TARGET then
		insert (IDRMP,RMPNAME,DL_USLOV,DATEBEG,DATEEND)
		values (F1,F2,F3,DATEBEG,DATEEND);

	set @rez = isnull(@@ROWCOUNT,0)
	if @@ERROR<>0 set @i = 1
end


endall: 

if @i=1  rollback tran
else
  commit tran /*принять действия выполненные по транзакции */

EXEC sp_xml_removedocument @idxml

select @i as ERR,@rez as REZ

end



