ALTER PROCEDURE [dbo].[p_doc_schet_foms] @sc int
AS
BEGIN
WITH Z AS (select max(SUMV) sumv,max(sl.P_CEL25)P_CEL25,max(OS_SLUCH_REGION) OS_SLUCH_REGION-- готовая выборка для всей поликлиники
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID = @sc
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID and (pa.SMO is null or pa.SMO not like '46%')
where zsl.usl_ok = 3 and (OS_SLUCH_REGION IS NULL OR OS_SLUCH_REGION in (4,5,6,21,29,30,31,32,33,34,35,36,39,40))
group by zsl.ID)

Select '1' n, 'Медицинская помощь в условиях круглосуточных стационаров' cel, sum(SUMV) sumv, count(*) cnt
from SLUCH zsl 
join D3_SCHET_OMS s on zsl.SCHET_ID = s.ID and s.ID = @sc
join PACIENT p on zsl.PID = p.ID and (p.SMO is null or p.SMO not like '46%')
where usl_ok = 1 and vid_hmp is null -- убрал вмп
UNION ALL

Select '2' n, 'Медицинская помощь в условиях дневных стационаров всех типов' cel, sum(SUMV) sumv, count(*) cnt
from SLUCH zsl 
join D3_SCHET_OMS s on zsl.SCHET_ID = s.ID and s.ID = @sc
join PACIENT p on zsl.PID = p.ID and (p.SMO is null or p.SMO not like '46%')
where usl_ok = 2
union all
Select '3' n, 'Амбулаторная помощь' cel
  , sum(SUMV) sumv, count(*) cnt
from z
UNION ALL
Select '' n, '  - с профилактическими и иными целями' cel, sum(SUMV) sumv, count(*) cnt
from z
where (isnull(z.P_CEL25,'1') not in  ('1.1','3.0','2.2') and OS_SLUCH_REGION is null) or (OS_SLUCH_REGION in (4,5,29,32,33,34))
UNION ALL
Select '' n, '  - Неотложной форме' cel, sum(SUMV) sumv, count(*) cnt
from z where P_CEL25 = '1.1'  -- новый код неотложки  = 1.1
UNION ALL
Select '' n, '  - Обращение по заболеванию' cel, sum(SUMV) sumv, count(*) cnt 
from z where (P_CEL25 = '3.0' and OS_SLUCH_REGION is null)
  or OS_SLUCH_REGION in (6,21,30,31,35,36,39) 
union all
Select '4' n, 'Скорая медицинская помощь в том числе:' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID = @sc
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID and (pa.SMO is null or pa.SMO not like '46%')
where zsl.usl_ok = 4 
UNION ALL
Select '' n, '   - экстренной форме' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID = @sc
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID and (pa.SMO is null or pa.SMO not like '46%')
where zsl.usl_ok = 4  and zsl.FOR_POM = 1 
UNION ALL
Select '' n, '   - неотложной форме' cel, sum(SUMV) sumv, count(*) cnt
from D3_ZSL_OMS zsl 
join D3_SL_oms sl on zsl.ID = sl.D3_ZSLID
join d3_schet_oms sc on zsl.D3_SCID = sc.ID and sc.ID = @sc
join d3_PACIENT_oms pa on zsl.D3_PID = pa.ID and (pa.SMO is null or pa.SMO not like '46%')
where zsl.usl_ok = 4  and zsl.FOR_POM = 2 



END