-- процедура заполняет таблицы T данными из плоской таблицы TVER31
CREATE PROCEDURE [dbo].[p_t_fillTfromVer31] 
@rez    nvarchar(1000) 
OUTPUT AS --19.03.2019 texnix  --07.08.2019 новые поля для иваново.
BEGIN --возвращает код ошибки, и описание ошибки
--айдишники счетов, которые заполняются - берутся из T_SCHET

-- забиваем данные в таблицы.
SET XACT_ABORT ON;  

set @rez = ''


declare  @sct  table (sc int)
insert into @sct select distinct c.id FROM T_VER31 pr join D3_SCHET_OMS c on pr.CODE=c.CODE and c.CODE_MO=pr.CODE_MO and c.NSCHET=pr.NSCHET and pr.dschet=c.dschet 
declare @schets varchar(max)=
(select cast(sc as varchar(10)) + ', ' from @sct for xml path('') )
--select @sc

exec P_delSchets @schets
--вынесу трай за удаление счетов. чтобы быстрее работало.
BEGIN TRY  
BEGIN TRANSACTION; 
--подготавливаем временки
insert into D3_SCHET_OMS (Code,code_mo,year,month,nschet,dschet,plat,OmsFileName,COMENTS,ZapFileName) 
sELECT distinct Code,code_mo,year,month,nschet,dschet,plat,OmsFileName,COMENTS,case when left(plat,2)in ('69','74') then 'dbf' when left(plat,2)='37' then 'ora' end as ZapFileName
  FROM T_VER31 pr where Code is not null

update pr set SC =c.id from T_VER31 pr 
				join D3_SCHET_OMS c on pr.CODE=c.CODE and c.CODE_MO=pr.CODE_MO and c.NSCHET=pr.NSCHET and pr.dschet=c.dschet where pr.CODE is not null
-- обновляем айди реестра у остальных записей
update pr set sc=(select top 1 sc from T_VER31 pr2 where pr2.zsl_id=pr.zsl_id and pr2.sc is not null)
from T_VER31 pr 

--обновляем уиды.
update T_VER31 set UID_ZSL=HASHBYTES('SHA1', ZSL_ID+cast(SC as varchar(10))	)
,UID_SL =  HASHBYTES('SHA1', ZSL_ID+SL_ID+cast(SC as varchar(10)) )
,UID_PAC = HASHBYTES('SHA1', ZSL_ID+ID_PAC+cast(N_ZAP as varchar(10))+cast(SC as varchar(10)) )

--SET @m ='обновили счёт '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;
--delete from  #sc
--insert into #sc select distinct sc FROM T_VER31 pr --записываем свежие счета

SET DATEFORMAT ymd; 

truncate table T_SCHET
truncate table T_ZSL
truncate table T_SL
truncate table T_SL_FK
truncate table T_USL
--SET @m ='очистили Т '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;
--запоминаем вставленные счета
insert into T_SCHET (sc,Code,code_mo,year,month,nschet,dschet,plat,OmsFileName,COMENTS,ZapFileName) 
sELECT distinct sc,Code,code_mo,year,month,nschet,dschet,plat,OmsFileName,COMENTS,case when left(plat,2)in ('69','74') then 'dbf' when left(plat,2)='37' then 'ora' end as ZapFileName
  FROM T_VER31 pr where Code is not null

--SET @m ='тсчёт '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;

insert into T_ZSL
(UID_ZSL,UID_PAC,SC,[ID_PAC],[FAM],[IM],[OT],[W],[DR],[FAM_P],[IM_P],[OT_P],[W_P],[DOCTYPE],[DOCSER],[DOCNUM]
,[VPOLIS],[SPOLIS],[NPOLIS],[SMO],[NOVOR],[VNOV_D],SOCSTATUS,AdressP
,ST_OKATO,SMO_OK
,[ZSL_ID],[IDCASE],[VIDPOM],[FOR_POM],[NPR_MO],[LPU]
,[DATE_Z_1],[DATE_Z_2],[KD_Z],[RSLT],[ISHOD],[OS_SLUCH_REGION],[IDSP],[SUMV],[OPLATA],[SUMP],[USL_OK],[T_ARRIVAL],[N_ZAP],[PR_NOV])
select distinct UID_ZSL,UID_PAC,SC,[ID_PAC],[FAM],[IM],[OT],[W],case when isdate([DR])=1 then DR end,[FAM_P],[IM_P],[OT_P],[W_P],[DOCTYPE],[DOCSER],[DOCNUM]
,[VPOLIS],[SPOLIS],[NPOLIS],PLAT as SMO,[NOVOR],[VNOV_D],SOCSTATUS,AdressP
,case when len([ST_OKATO])<6 then ST_OKATO end ST_OKATO,case when len([SMO_OK])<6 then SMO_OK end SMO_OK 
,[ZSL_ID],[IDCASE],[VIDPOM],[FOR_POM],[NPR_MO],[LPU]
,[DATE_Z_1],[DATE_Z_2],[KD_Z],[RSLT],[ISHOD],[OS_SLUCH_REGION],[IDSP],[SUMV],[OPLATA],[SUMP],[USL_OK],[T_ARRIVAL],[N_ZAP],[PR_NOV]
FROM T_VER31 pr  where ID_PAC is not null
--SET @m ='тзсл '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;




INSERT INTO T_SL
(UID_ZSL,UID_SL,sc,D3_ZSLGID,[SL_ID],PODR ,PROFIL,PROFIL_K,DET ,NHISTORY,DATE_1,DATE_2,KD,DS0,DS1,C_ZAB,DS_ONK,DN,N_KSG,COMENTSL,
PRVS,VERS_SPEC,IDDOKT,ED_COL,SUM_M,POVOD,PROFIL_REG,GRAF_DN,KSKP,VID_VIZ,VID_BRIG )
select distinct UID_ZSL,UID_SL,sc,ZSL_ID,SL_ID ,PODR ,PROFIL,PROFIL_K, DET ,NHISTORY,DATE_1,DATE_2,KD,DS0,DS1,C_ZAB,DS_ONK,DN,N_KSG,COMENTSL,
PRVS,'021',IDDOKT,ED_COL,SUM_M,POVOD,PROFIL_REG,GRAF_DN,KSKP,VID_VIZ,VID_BRIG 
FROM T_VER31 pr  where DATE_1 is not null


--корректируем T_ZSL

update zsl set sumV=summ from
(select max(sl.sum_m) summ,sl.UID_ZSL  from T_ZSL zsl join T_SL sl on zsl.UID_ZSL=sl.UID_ZSL where zsl.IDSP=30 
	group by sl.UID_ZSL ) k join T_ZSL zsl on zsl.UID_ZSL=k.UID_ZSL 
--проставляем в общую сумму беря максимальную из посещений (в твери в последнем посещении высчитывается основная)

update zsl set sumV=summ from
(select sum(sl.sum_m) summ,sl.UID_ZSL from T_ZSL zsl join T_SL sl on zsl.UID_ZSL=sl.UID_ZSL where zsl.IDSP=25 
	group by sl.UID_ZSL ) k join T_ZSL zsl on zsl.UID_ZSL=k.UID_ZSL 
--в подушевом суммируются все случаи внутри обращения


insert into T_SL_FK (UID_SL,sc,D3_SLGID,D3_ZSLGID,N_KSG,VER_KSG,KSG_PG,N_KPG,KOEF_Z,KOEF_UP,BZTSZ,KOEF_D,KOEF_U,SL_K,IT_SL
	,NAPR_DATE,NAPR_MO,NAPR_V,MET_ISSL,NAPR_USL,PR_CONS,DT_CONS
	,DS1_T,STAD,ONK_T,ONK_N,ONK_M,MTSTZ,SOD,K_FR 	,[WEI] ,[HEI] 	,[BSA]
	,DIAG_DATE,DIAG_TIP,DIAG_CODE,DIAG_RSLT,REC_RSLT,PROT,D_PROT 
	,USL_TIP,HIR_TIP,LEK_TIP_L,LEK_TIP_V,LUCH_TIP
	,REGNUM,DATE_INJ,CODE_SH
	,NAZ_N,NAZ_R,NAZ_SP,NAZ_V,NAZ_USL,NAZ_PMP,NAZ_PK
	,IDSL,Z_SL,CRIT,[DS],DS_PR,[DS_TYPE]
	, PR_DS2_N)
	select distinct UID_SL,sc,SL_ID,ZSL_ID,N_KSG,VER_KSG,KSG_PG,N_KPG,KOEF_Z,KOEF_UP,BZTSZ,KOEF_D,KOEF_U,SL_K,IT_SL
	,NAPR_DATE,NAPR_MO,NAPR_V,MET_ISSL,NAPR_USL,PR_CONS,DT_CONS
	,DS1_T,STAD,ONK_T,ONK_N,ONK_M,MTSTZ,SOD,K_FR 	,[WEI] ,[HEI] 	,[BSA] 
	,DIAG_DATE,DIAG_TIP,DIAG_CODE,DIAG_RSLT,REC_RSLT,PROT,D_PROT
	,USL_TIP,HIR_TIP,LEK_TIP_L,LEK_TIP_V,LUCH_TIP
	,REGNUM,DATE_INJ,CODE_SH
	,case when NAZ_R is not null then 1 end NAZ_N,NAZ_R,NAZ_SP,NAZ_V,NAZ_USL,NAZ_PMP,NAZ_PK
	,IDSL,Z_SL,CRIT,DS2,DS2_PR,case when ds2 is not null then 2 end DS_TYPE	 --сопутствующие диагнозы в приказе в одном виде, в бд в другом.
	,PR_DS2_N
FROM T_VER31 pr --where DATE_1 is not null --чтобы нуллы не пихать

insert into  T_USL (UID_SL,sc,IDSERV ,[D3_SLGID] ,D3_ZSLGID,LPU 
		,LPU_1 ,PODR ,PROFIL,VID_VME,DET ,DATE_IN,DATE_OUT ,P_OTK ,DS,CODE_USL
		,KOL_USL,TARIF,SUMV_USL,PRVS--,PRVD
		,CODE_MD,NPL,COMENTU,KOD_SP,FORMUL )
	select distinct UID_SL,sc,IDSERV ,SL_ID ,ZSL_ID,LPU 
		,LPU_1 ,U_PODR ,U_PROFIL,VID_VME,DET ,DATE_IN,DATE_OUT ,P_OTK ,DS,CODE_USL
		,KOL_USL,U_TARIF,SUMV_USL,U_PRVS--,PRVD
		,CODE_MD,NPL,COMENTU,KOD_SP,FORMUL 
FROM T_VER31 pr where DATE_IN is not null
print 'коммит Т'



--обновляем уиды.
update T_ZSL set UID_ZSL=HASHBYTES('SHA1', ZSL_ID+cast(SC as varchar(10))	)
,UID_PAC = HASHBYTES('SHA1', ZSL_ID+ID_PAC+cast(N_ZAP as varchar(10))+cast(SC as varchar(10)) )

UPDATE T_SL set UID_SL =  HASHBYTES('SHA1', D3_ZSLGID+SL_ID+cast(SC as varchar(10)) )
, UID_ZSL=HASHBYTES('SHA1', D3_ZSLGID+cast(SC as varchar(10))	)

UPDATE T_USL set UID_SL =  HASHBYTES('SHA1', D3_ZSLGID+[D3_SLGID]+cast(SC as varchar(10)) )
update T_SL_FK set 	 UID_SL =  HASHBYTES('SHA1', D3_ZSLGID+[D3_SLGID]+cast(SC as varchar(10)) )

COMMIT TRANSACTION;  
--тестовый роллбак
--ROLLBACK TRANSACTION; 
END TRY
BEGIN CATCH  
	--EXECUTE usp_GetErrorInfo; 
	IF (XACT_STATE()) = -1  
		begin
        ROLLBACK TRANSACTION; 
		set @rez =  cast('стр:'+cast(ERROR_LINE() as varchar(20)) +' '+ERROR_MESSAGE() as nvarchar(250))
		end
	IF (XACT_STATE()) = 1  
		COMMIT TRANSACTION;  	
END CATCH; 


END