-- процедура заполняет таблицы D3 данными из таблиц T_
ALTER PROCEDURE [dbo].[p_t_fillD3] @rez    nvarchar(1000) OUTPUT AS --19.03.2019 texnix --07.08.2019 новые поля иваново
BEGIN --возвращает код ошибки, и описание ошибки
--айдишники счетов, которые заполняются - берутся из T_SCHET

-- забиваем данные в таблицы.
SET XACT_ABORT ON;  

set @rez = ''
BEGIN TRY  
BEGIN TRANSACTION; 

--SET @m ='заполнили т '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;
--если не проставлены даты случая, проставляем их
update l set date_z_1 = data -- проставляем первую дату в случае из первого посещения
from  (select min(sl.date_1) data,sl.UID_ZSL from T_ZSL s join T_SL sl on sl.UID_ZSL=s.UID_ZSL
where s.DATE_Z_1 is null 
group by sl.UID_ZSL ) d1 join T_ZSL l on d1.UID_ZSL=l.UID_ZSL


update l set date_z_2 = data -- проставляем последнюю
from  (select max(sl.date_2) data,sl.UID_ZSL from T_ZSL s join T_SL sl on sl.UID_ZSL=s.UID_ZSL
where s.DATE_Z_2 is null 
group by sl.UID_ZSL ) d1 join T_ZSL l on d1.UID_ZSL=l.UID_ZSL

INSERT INTO [dbo].[D3_PACIENT_OMS]
(UID,[D3_SCID],[ID_PAC],[FAM],[IM],[OT],[W],[DR],[TEL],[FAM_P],[IM_P],[OT_P],[W_P],[DR_P],[MR],[DOCTYPE],[DOCSER],[DOCNUM],[SNILS]
,[OKATOG],[OKATOP],[COMENTP],[VPOLIS],[SPOLIS],[NPOLIS],[ST_OKATO],[SMO],[SMO_OGRN]
,[SMO_OK],[SMO_NAM],[INV],[MSE],[NOVOR] 
,N_ZAP,SOCSTATUS,AdressP 
,[VNOV_D],LPU_P,LPU_DATE)
select	distinct UID_PAC,SC,ID_PAC,[FAM],[IM],[OT],[W]
,case when isdate([DR])=1 then DR end
,[TEL],[FAM_P],[IM_P],[OT_P],[W_P],[DR_P],[MR],[DOCTYPE],[DOCSER],[DOCNUM],[SNILS]
,[OKATOG],[OKATOP],[COMENTP],[VPOLIS],[SPOLIS],[NPOLIS]
,case when len([ST_OKATO])<6 then ST_OKATO end ST_OKATO -- алтай04, длинное получается иногда окато. 84701000
,[SMO],[SMO_OGRN]
,case when len([SMO_OK])<6 then SMO_OK end SMO_OK -- алтай04, туда зачем то пихают дату рождения
,[SMO_NAM],[INV],[MSE],[NOVOR]
,N_ZAP,SOCSTATUS,AdressP 
,[VNOV_D],LPU_P,LPU_DATE from T_ZSL

--удаление дубликатов, которые получились в результате неверного заполнения паспорта/снилса итд.
declare @reg char(2) =  (select cast(Parametr as varchar(2))  from Settings where name='REGION') -- номер региона

if @reg in ('74','69','37') -- только у тех у кого есть дбф 
			delete from d3_pacient_oms where id in
			(select id from
			(select
			DENSE_RANK() over (partition by t1.UID order by t2.id) r
			,t1.id
			from D3_PACIENT_OMS t1
			join D3_PACIENT_OMS t2 on t1.id=t2.id
			where exists (select sc from T_SCHET where sc=t1.D3_SCID and sc=t2.D3_SCID)  ) k where r>1 )


INSERT INTO [dbo].[D3_ZSL_OMS]
		(			UID,[ZSL_ID]	,[D3_PID],[D3_PGID],N_ZAP,PR_NOV,[D3_SCID],[IDCASE],USL_OK
		,P_CEL
			,[VIDPOM],[FOR_POM],[NPR_MO],[LPU],[VBR],[DATE_Z_1],[DATE_Z_2],[P_OTK],[RSLT_D],[KD_Z],[VNOV_M],[RSLT],[ISHOD],[OS_SLUCH]
			,[OS_SLUCH_REGION],[VOZR],[VB_P],[IDSP],[SUMV],[OPLATA],[SUMP],[SANK_IT]
			,NPR_DATE,DTP,T_ARRIVAL)
		Select		UID_ZSL,tt.zsl_id		,pa.ID	,tt.ID_PAC,tt.N_ZAP,tt.PR_NOV ,pa.d3_SCID	,[IDCASE],USL_OK
		,cast(tt.[P_CEL] as varchar(3)) as P_CEL -- отрезаем лишние символы, в алтае04 миац 5 символов в цели использует.
			,[VIDPOM],[FOR_POM],[NPR_MO],[LPU],[VBR],[DATE_Z_1],[DATE_Z_2],[P_OTK],[RSLT_D],[KD_Z],[VNOV_M],[RSLT],[ISHOD],[OS_SLUCH]
			,[OS_SLUCH_REGION],[VOZR],[VB_P],[IDSP],[SUMV],[OPLATA],[SUMP],[SANK_IT]
			,NPR_DATE,DTP,T_ARRIVAL
		From T_ZSL tt join d3_pacient_oms pa on tt.UID_PAC = pa.UID


INSERT INTO [dbo].[D3_SL_OMS]
					(UID,[D3_ZSLID],[D3_ZSLGID],[SL_ID],[USL_OK]
		,[VID_HMP],[METOD_HMP],[LPU_1],[PODR],[PROFIL],PROFIL_K,[DET],[P_CEL],[TAL_NUM],[TAL_D],[TAL_P],[NHISTORY],[P_PER],[DATE_1]
		,[DATE_2],[KD],[DS0],[DS1],[DS1_PR],[C_ZAB] ,DS_ONK  ,[DN],[CODE_MES1],[CODE_MES2],[KSG_DKK]
		,[N_KSG],[KSG_PG],[SL_K],[IT_SL]--,VER_KSG ,N_KPG,KOEF_Z ,KOEF_UP ,BZTSZ,	KOEF_D ,KOEF_U,	DKK1 ,	DKK2 -- блок ксг
		,[REAB],[PRVS],PRVD,[VERS_SPEC],[IDDOKT],[ED_COL],[TARIF],[SUM_M]
		,[COMENTSL],POVOD,PROFIL_REG,GRAF_DN,KSKP,VID_VIZ,VID_BRIG
		,PRVS21,P_CEL25 --для курского фонда, заполнение полей (для расчёта мэков)
		)

		Select      UID_SL,zsl.ID,		zsl.ZSL_ID,	tt.SL_ID,tt.[USL_OK]
		,[VID_HMP],[METOD_HMP],LPU_1,[PODR],[PROFIL],PROFIL_K,[DET]
		,cast(tt.[P_CEL] as varchar(3)) as P_CEL -- отрезаем лишние символы, в алтае04 миац 5 символов в цели использует.
		,[TAL_NUM],[TAL_D],[TAL_P],[NHISTORY],[P_PER],[DATE_1]
		,[DATE_2],[KD],[DS0],[DS1],[DS1_PR],[C_ZAB] ,DS_ONK ,[DN],[CODE_MES1],[CODE_MES2],[DKK1]
		,[N_KSG],[KSG_PG],[SL_K],[IT_SL]--,VER_KSG ,N_KPG,KOEF_Z ,KOEF_UP ,BZTSZ,	KOEF_D ,KOEF_U,	DKK1 ,	DKK2
		,[REAB],[PRVS],PRVD,isnull([VERS_SPEC],'V021') VERS_SPEC,[IDDOKT],[ED_COL],[TARIF],[SUM_M]
		,cast([COMENTSL] as nvarchar(250)) COMENTSL,POVOD,PROFIL_REG,GRAF_DN,KSKP,VID_VIZ,VID_BRIG
		,PRVS,cast(tt.[P_CEL] as varchar(3)) as P_CEL
	From T_SL tt	join D3_ZSL_OMS zsl on tt.UID_ZSL=zsl.UID

--привязываем всю таблицу подтаблиц к SL

update k set d3_SLID = sl.id
from T_SL_FK k join D3_SL_OMS sl on k.UID_SL=sl.UID
	
--if @@ERROR<>0 set @i = @i+1

--теперь легко и непринуждённо вставляем ксг.
 INSERT INTO D3_KSG_KPG_OMS (D3_SLID,N_KSG,VER_KSG,KSG_PG,N_KPG,KOEF_Z,KOEF_UP,BZTSZ,KOEF_D,KOEF_U,DKK1,DKK2,SL_K,IT_SL)
 Select distinct tt.D3_SLID,tt.N_KSG,tt.VER_KSG,tt.KSG_PG,tt.N_KPG,tt.KOEF_Z,tt.KOEF_UP,tt.BZTSZ,tt.KOEF_D,tt.KOEF_U,tt.DKK1,tt.DKK2,tt.SL_K,tt.IT_SL
 from T_SL_FK tt where tt.D3_SLID is not null and (tt.N_KSG is not null or tt.N_KPG is not null)

--критерии
 INSERT INTO D3_CRIT_OMS (D3_KSGID,D3_KSGGID,CRIT)
	Select		distinct ksg.id,tt.d3_slgid,tt.crit
	From T_SL_FK tt 
	join D3_KSG_KPG_OMS ksg on tt.d3_slid=ksg.d3_slid
	where tt.crit is not null

--теперь привязываем коэффициенты к ксг
update k set KSGID = ks.id
from T_SL_FK k join D3_KSG_KPG_OMS ks on k.d3_SLID = ks.D3_SLID

--вставляем в 3.1 версию коэффициентов
insert into d3_SL_KOEF_OMS (D3_KSGID,IDSL,Z_SL) 	select KSGID,IDSL,Z_SL from  T_SL_FK  where IDSL is not null and KSGID is not null

--вставляем направления
 INSERT INTO [dbo].D3_NAPR_OMS (D3_SLID,D3_SLGID,NAPR_DATE,NAPR_MO,NAPR_V,MET_ISSL,NAPR_USL)
 Select tt.D3_SLID,tt.D3_SLGID,tt.NAPR_DATE,tt.NAPR_MO,tt.NAPR_V,tt.MET_ISSL,tt.NAPR_USL
 from T_SL_FK tt  where tt.NAPR_DATE is not null and NAPR_V is not null

--вставляем консультации
 INSERT INTO [dbo].D3_CONS_OMS (D3_SLID,D3_SLGID,PR_CONS,DT_CONS)
  Select tt.D3_SLID,tt.D3_SLGID,tt.PR_CONS,tt.DT_CONS
	from T_SL_FK tt  where tt.PR_CONS is not null or tt.PR_CONS is not null

--вставляем онкологию
 INSERT INTO [dbo].D3_ONK_SL_OMS (D3_SLID,D3_SLGID,DS1_T,STAD,ONK_T,ONK_N,ONK_M,MTSTZ,SOD
	,K_FR 	,[WEI] ,[HEI] 	,[BSA] 	)
 Select tt.D3_SLID,tt.D3_SLGID,tt.DS1_T,tt.STAD,tt.ONK_T,tt.ONK_N,tt.ONK_M,tt.MTSTZ,tt.SOD
 ,K_FR 	,[WEI] ,[HEI] 	,case when left(BSA,1)='.' then '0'+BSA else right(BSA,4) end  --обрабатываем ошибку (в владивостоке) когда первую цифру не пишут.
 from T_SL_FK tt where tt.DS1_T is not null or tt.STAD is not null
--if @@ERROR<>0 set @i = @i+1

--привязываем блок диаг, противо, онкоуслуги к онко
 update k set d3_ONKSLID = onk.id
from T_SL_FK k 
	join D3_ONK_SL_OMS onk on onk.D3_SLGID=k.D3_SLGID and k.d3_slid=onk.d3_slid
where USL_Tip is not null Or DIAG_DATE is not null or PROT is not null
--if @@ERROR<>0 set @i = @i+1
-- вставляем диагблоконко
 INSERT INTO [dbo].D3_B_DIAG_OMS (D3_ONKSLID,D3_ONKSLGID,DIAG_DATE,DIAG_TIP,DIAG_CODE,DIAG_RSLT,REC_RSLT)
 Select tt.D3_ONKSLID,tt.D3_slgid,tt.DIAG_DATE,tt.DIAG_TIP,tt.DIAG_CODE,tt.DIAG_RSLT,tt.REC_RSLT
 from T_SL_FK tt where tt.DIAG_DATE is not null and d3_ONKSLID is not null
 --if @@ERROR<>0 set @i = @i+1

--вставляем противоонко
 INSERT INTO [dbo].D3_B_PROT_OMS (D3_ONKSLID,D3_ONKSLGID,PROT,D_PROT)
 Select tt.D3_ONKSLID,tt.D3_slgid,tt.PROT,tt.D_PROT
 from T_SL_FK tt where tt.D3_ONKSLID is not null and PROT is not null
 --if @@ERROR<>0 set @i = @i+1

--вставляем онкоуслуги
 INSERT INTO [dbo].D3_ONK_USL_OMS (D3_ONKSLID,D3_ONKSLGID,USL_TIP,HIR_TIP,LEK_TIP_L,LEK_TIP_V,LUCH_TIP)
  Select tt.D3_ONKSLID,tt.D3_slgid,tt.USL_TIP,tt.HIR_TIP,tt.LEK_TIP_L,tt.LEK_TIP_V,tt.LUCH_TIP
 from T_SL_FK tt where  tt.D3_ONKSLID is not null and (LEK_TIP_L is not null or HIR_TIP is not null or LUCH_TIP is not null)  --если хир или лек не заполнено, не берём (в лекарствах USL_TIP заполняется_
 --привязываем блок лекарств к онкоуслуге
 update k set d3_ONKUSLID = onu.id
 --select *

from T_SL_FK k 
	join D3_ONK_USL_OMS onu on onu.D3_ONKSLID=k.D3_ONKSLID 
							and k.USL_TIP=onu.USL_TIP
							and k.regnum is not null

--вставляем лекарства
 INSERT INTO [dbo].D3_LEK_PR_OMS (D3_ONKUSLID,D3_ONKUSLGID,REGNUM,DATE_INJ,CODE_SH)
 Select tt.D3_ONKUSLID,tt.D3_slgid,tt.REGNUM,tt.DATE_INJ,CODE_SH
 from T_SL_FK tt where  tt.D3_ONKUSLID is not null

 INSERT INTO [dbo].D3_NAZ_OMS (D3_SLID,D3_SLGID,NAZ_N,NAZ_R,NAZ_SP,NAZ_V,NAZ_USL,NAPR_DATE,NAPR_MO,NAZ_PMP,NAZ_PK)
  Select tt.D3_SLID,tt.D3_SLGID,tt.NAZ_N,tt.NAZ_R,tt.NAZ_SP,tt.NAZ_V,tt.NAZ_USL,tt.NAPR_DATE,tt.NAPR_MO,tt.NAZ_PMP,tt.NAZ_PK
 from T_SL_FK tt where tt.NAZ_R is not null and D3_SLID is not null

	INSERT INTO [dbo].[D3_USL_OMS]
				([D3_SLID]	,[D3_ZSLID]	,[D3_SLGID]	,	[IDSERV]
	,[LPU],[LPU_1]		,[PODR],[PROFIL],[VID_VME],[DET],[DATE_IN],[DATE_OUT],[P_OTK],[DS],[CODE_USL]
	,[KOL_USL],[TARIF],[SUMV_USL],[PRVS],VERS_SPEC,PRVD,[CODE_MD],[NPL],[COMENTU],KOD_SP,FORMUL)
	Select		sl.ID	,	sl.d3_zslid		,SL_ID		,	tt.[IDSERV]
	,tt.[LPU],tt.LPU_1,tt.[PODR],tt.[PROFIL],tt.[VID_VME],tt.[DET],tt.[DATE_IN],tt.[DATE_OUT],tt.[P_OTK],tt.[DS],tt.[CODE_USL]
	,tt.[KOL_USL],tt.[TARIF],tt.[SUMV_USL],tt.[PRVS],'V021',tt.PRVD,tt.[CODE_MD],tt.[NPL],tt.[COMENTU],tt.KOD_SP,tt.FORMUL
	From T_USL tt 
	join D3_SL_OMS sl on tt.UID_SL=sl.UID


INSERT INTO [dbo].[D3_DSS_OMS]
				([D3_SLID],[D3_SLGID],[DS],[DS_PR],[DS_TYPE],PR_DS2_N)
	Select		 d3_slid,tt.[D3_SLGID],tt.[DS],tt.[DS_PR],tt.[DS_TYPE],tt.PR_DS2_N
	From T_SL_FK tt where ds is not null


--заполняем некоторые поля:
/*
update l set date_z_2 = data -- проставляем вторую дату в случае из последнего посещения
from  (select max(sl.date_2) data,sl.d3_zslid from D3_ZSL_OMS zsl join [D3_SL_OMS] sl on sl.d3_zslid=zsl.id
and exists (select sc from T_SCHET where sc=zsl.d3_scid) 
group by sl.d3_zslid ) d1 join d3_zsl_oms l on d1.d3_zslid=l.id
where date_z_2 is null

update l set date_z_1 = data -- проставляем первую дату в случае из первого посещения
from  (select min(sl.date_1) data,sl.d3_zslid from D3_ZSL_OMS zsl join [D3_SL_OMS] sl on sl.d3_zslid=zsl.id
and exists (select sc from T_SCHET where sc=zsl.d3_scid) 
group by sl.d3_zslid ) d1 join d3_zsl_oms l on d1.d3_zslid=l.id
where date_z_1 is null
*/

	-- проставляем возраст.
update zsl set vozr=cast((year( dateadd(d,-1,date_z_1)-p.[DR] )-1900) as varchar(3))
from d3_zsl_oms zsl join d3_pacient_oms p on zsl.d3_pid=p.id 
and zsl.d3_scid=p.d3_scid
where vozr is null and exists (select sc from T_SCHET t where t.sc=zsl.D3_SCID)

--обновляем гуид в ксг
update ksg set d3_slgid=sl.SL_ID
from d3_zsl_oms zsl join d3_sl_oms sl on sl.d3_zslid=zsl.id
join d3_pacient_oms pa on pa.id=zsl.d3_pid
join d3_ksg_kpg_oms ksg on ksg.d3_slid=sl.id
where ksg.D3_SLGID is null	and exists (select sc from T_SCHET t where t.sc=zsl.D3_SCID)

--некоторые МО посылают диагнозы в виде: D24. (пермь) 
update sl set ds1=left(ds1,3) 
from d3_zsl_oms zsl join d3_sl_oms sl on sl.d3_zslid=zsl.id
where right(ds1,1)='.' and exists (select sc from T_SCHET t where t.sc=zsl.D3_SCID)

-- проставляем сумму выставленную
update s set SUMMAV=zsl.sumV, SD_Z=zsl.cnt --сумма счёта идёт без способа оплаты 25 и 36 44
from (
select sum(sumO) sumv,d3_scid, count(*) cnt
from d3_zsl_oms  group by d3_scid ) zsl
 join D3_SCHET_OMS s on zsl.d3_scid=s.id 
where exists (select sc from T_SCHET where sc=s.id)  and SUMMAV is null --там где стоит, значит уже проставили

--чисто для читы регламента у них нет, а желание засовывать в особый случай региональные данные есть
if @reg='75'
		update s set OS_SLUCH_REGION=OS_SLUCH
		from d3_zsl_oms s
		 where exists (select sc from T_SCHET where sc=s.D3_SCID)


--удаляем лишние онкоуслуги
delete osl from D3_ZSL_OMS zsl join d3_sl_oms sl on zsl.id=sl.d3_zslid 
join [dbo].[D3_ONK_SL_OMS] osl on sl.id=osl.D3_SLID and
 exists (select sc from T_SCHET where sc=zsl.D3_SCID) 
where not (sl.ds1 like 'C%' or left(sl.ds1,3) in ('D01','D02','D03','D04','D05','D06','D07','D08','D09'))
--SET @m ='конец '+cast( SYSDATETIME() as varchar(30))
--RAISERROR(@m,16,10)WITH NOWAIT;


COMMIT TRANSACTION;  
--тестовый роллбак
--ROLLBACK TRANSACTION; 
END TRY
BEGIN CATCH  
	--EXECUTE usp_GetErrorInfo; 
	IF (XACT_STATE()) = -1  
		begin
        ROLLBACK TRANSACTION; 
		set @rez =  cast('стр:'+cast(ERROR_LINE() as varchar(20)) +' '+ERROR_MESSAGE() as nvarchar(250))
		end
	IF (XACT_STATE()) = 1  
		COMMIT TRANSACTION;  	
END CATCH; 


END